/**
 * Program Name: parseTask.java
 *
 * Comments: Provides methods for interacting with tasks in the Job 
 * Description xml file.  A task consists of one or more interconnected
 * jobs that should be run in a particular order.
 *
 * This program assumes that the job description xml file has already been
 * read and parsed.
 */

package extensions.generic;

import java.util.*;
import org.escience.XSIL.*;
import java.io.*;

public class parseTask extends XSIL {

    XSIL root;
    Hashtable taskHash=new Hashtable();

    /**
     * The following two methods are required by the XSIL parent
     * class.  We override them here.  For current purposes there is
     * no distinction between contruct() and instantiate();
     */ 
    public void construct() {
	for(int ichild=0;ichild<getChildCount(); ichild++) {
	    XSIL x=getChild(ichild);
	    if(x instanceof Param) {
		Param p=(Param)x;
		taskHash.put(p.getName(),p.getText());
	    }
	    else if(x instanceof parseJob) {
		parseJob pg=(parseJob)x;
	    }
	}
    }
    
    public void instantiate() {
	construct();
    }

    public Hashtable getTaskHash() {
	return taskHash;
    }
}

