package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.Base64.*;
//import WebFlow.Charon.*;
import org.omg.CORBA.*;
import WebFlow.xml.*;
import WebFlow.hashtable.*;
import WebFlow.FB.*;
import WebFlow.ContextManager.*;
import WebFlow.RemoteFile.*;
import WebFlow.submitJob.*;
import java.lang.reflect.*;
//import WebFlow.PSEscript;
import java.util.*;

/////Added////////////////////
import orbasec.corba.Opaque;
/////Added////////////////////

public class ClientTest extends HttpServlet {
    private ORB orb;
    private org.omg.CORBA.Object m1,m2,m3,m4,m5,m6,m7;
    ContextData cd;
    SaveContext sc;
    ContextManager cm;
    XmlServer aad;
    RemoteFile rf;
    submitJob sj;
    FBServer fb;
    private WebFlowContext ws = null;
    PrintWriter out;
    private String ior;
    private WebFlowContext masterServer, userContext;
    private boolean notReady, masterOn, userContextOn;
    private int icount;
    private String masterRef, masterID;
    private String userName;

    /////Added////////////////////
    org.omg.SecurityLevel2.Current current=null;
    /////Added////////////////////

    //The following should be in a properties file.

    private final String masterIOR="/app/gateway/apache/htdocs/SciPortal/IOR/master.txt";
    private final String userDir = "/app/gateway/apache/htdocs/SciPortal/WEB-INF/Descriptors/users";
    private final String entryToolkitDir = "/app/gateway/apache/htdocs/SciPortal/WEB-INF/Data/entryToolkit";
    
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	doPost(req, res);
    }
    
    protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	
	System.out.println("start servlet");
	out = res.getWriter();
	res.setContentType("text/html");
	
	String[] args = new String[1];
	args[0]=req.getParameter("config");
	userName=req.getParameter("UserName");

	/**
	 * KERBEROS ADDITION
	 * Set up the properties as expected by Orbasec 
	 */

	/* first check whether the master server is already running */	
	masterOn=false;
	masterRef = ReadIORFromFile(masterIOR);
	if(masterRef.length()>10) {
	    try {
		orb = ModuleManager.orb;
		if(getMaster(masterRef)) {
		    if(pingServer(masterServer)) {
			masterOn=true;
			masterID = masterServer.getObjectID();  
		    }
		}
	    } 
	    catch (java.lang.NullPointerException npe) {} 
	}
	
	if(!masterOn) {
	    //out.println("Sorry, the Gateway Server is down.");
	}
	
	else {
	    //out.println("The Gateway Server is on<br>");
	    
	    /** 
	     * Learn the user id 
	     * For ASC I pass this as a parameter from the CharonStart.html
	     * page.
	     */
	
	    /* check whether the user context is already running */
	    
	    System.out.println("Doing the rest of the stuff");
	    userContextOn = false;
	    try {  
		org.omg.CORBA.Object ouc = 
		    masterServer.getContext(masterID+"/"+userName);
		userContext = WebFlowContextHelper.narrow(ouc);
		if(pingServer(userContext)) {
		    userContextOn = true;
		    //		    CopyWebPage("GatewayPortal.html");    
		}
		else {
		    //out.println("user context is off<br>");
		    userContextOn = false;
		}  
	    } 
	    catch (Exception e) {
		//out.println("user context is off<br>");
		userContextOn = false;
	    }
	    
	    System.err.println("userContextOn? "+userContextOn);
	    
	    if(!userContextOn) {
		System.exit(0);
	    }
	    /* attach modules */
	    
	    m1 = userContext.addNewModule("ContextData");
	    cd  = ContextDataHelper.narrow(m1);
	    cd.test();
	    
	    System.out.println("attach SaveContext"); 
	    
	    m2 = userContext.addNewModule("SaveContext");
	    sc  = SaveContextHelper.narrow(m2);
	    sc.test();
	    
	    System.out.println("attach ContextManager"); 
	    
	    m3 = userContext.addNewModule("ContextManager");
	    cm  = ContextManagerHelper.narrow(m3);
	    cm.test();
	    
	    System.out.println("attach aad"); 
	    
	    /*
	      m4 = userContext.addNewModule("aad");
	      aad  = XmlServerHelper.narrow(m4);
	      aad.test();
	    */
	    
	    System.out.println("attach RemoteFile"); 
	    
	    m5 = userContext.addNewModule("RemoteFile");
	    rf  = RemoteFileHelper.narrow(m5);
	    rf.test();
	    
	    System.out.println("attach submitJob"); 
	    
	    m6 = userContext.addNewModule("submit");
	    sj  = submitJobHelper.narrow(m6);
	    sj.test();
	    
	    System.out.println("attach FileBrowser"); 
	    /*
	    m7 = userContext.addNewModule("FileBrowser");
	    fb  = FBServerHelper.narrow(m7);
	    fb.test();
	    */

	    System.out.println("initialize ContextManager");             
	    
	    cm.init(userContext,m2,m5);
	    
	    System.out.println("userName="+userName);
	    System.err.println(cm.getObjectID());
	    
	    // register modules and user context (for perfomance)
	    ModuleManager.setUserContext(userName,userContext);
	    ModuleManager.setContextManager(userName,cm);                     
	    //	    ModuleManager.setFileBrowser(userName,fb);
	    ModuleManager.setRemoteFile(userName,rf);
	    ModuleManager.setSubmitJob(userName,sj);
	    //ModuleManager.setAAD(userName,aad);
	
	
	    if(!cm.setUserContextData(userContext,userDir,userName)) {
		//Restore ContextData
		//read contents of the userContextData
	    
		String rootDir = userDir + "/" + userName;
		sc.readContextData(userContext,rootDir);
		
		System.out.println("now restore contexts");
		restoreChildren(userContext);
	    }
	    CopyWebPage("GatewayPortal.html");    
	}  
	
	System.err.println("about to flush 111");
	System.out.println("about to flush 222");
	fb.test();
	out.flush();
	out.close();
    }
    
    void error(String msg)
    {
	out.println(msg);
    }
    
    void status(String msg)
    {
	//out.println(msg);
    }
    
    public String getServletInfo()
    {
	return "By T. Haupt";
    }
    
    public synchronized void waitFor(long howLong) {
	try {
	    wait(howLong);
	} 
	catch (Exception e) {System.err.println(e);}
    }
    
    public String ReadIORFromFile(String masterIOR)   {
	//open a file
	FileInputStream theFile;
	BufferedReader fileReader;
	String sObjRef;
	
	try {
	    theFile=new FileInputStream(masterIOR);
	    fileReader=new BufferedReader(new InputStreamReader(theFile));
	}
	catch(FileNotFoundException e){
	    return "";
	}
	
	//read a reference string
	try {
	    sObjRef=fileReader.readLine();
	    System.err.println("Got the reference: "+sObjRef);
	}
	catch (IOException e) {
	    return "";
	}
	
	try {
	    theFile.close();
	    fileReader.close();
	}
	catch (IOException e) {}
	
	//return the reference string
	return sObjRef;
    }
    
    public boolean getMaster(String MasterRef){
	org.omg.CORBA.Object ws = orb.string_to_object(MasterRef);
	if(ws==null) return false;
	masterServer = WebFlowContextHelper.narrow(ws);
	if(masterServer==null) return false;
	else return true;
    }
    
    public boolean pingServer(WebFlowContext ws) {
	boolean non_exist = true;
	try{
	    non_exist = ws._non_existent();
	}
        catch(org.omg.CORBA.COMM_FAILURE ex){}
	catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

        return !non_exist;
    }       

    public void CopyWebPage(String fileName) {

       try {
         FileReader fr = new FileReader(entryToolkitDir+"/"+fileName);
         BufferedReader in = new BufferedReader(fr);
         while(true) {  
          String nextLine = in.readLine();
          if(nextLine == null) break;
          out.println(nextLine);
	 } 
         in.close();
       } catch (Exception e) { System.out.println(e);}         
    } 

    public void restoreChildren(WebFlowContext context) {
	System.out.println("starting restoration ...");
        if(cm==null) System.out.println("cm is null"); 
        if(context==null) System.out.println("context is null"); 
     String children=cm.getContextData(context,"Children");
     System.err.println("children: "+children); 
     String pDir=cm.getContextData(context,"Directory");
     System.err.println("directory: "+pDir); 
     if(children.equals("null")) { 
         // no more children: job done
         System.out.println("no more children: job done");
         return;
     }
     else {
         //Children are in format:  name1+name2+name3
         StringTokenizer st = new StringTokenizer(children,"+");
         if(st.hasMoreTokens()) {
             System.out.println("has more tokens");
	     String Child = st.nextToken();
             System.err.println("restore context "+Child);
             // create an empty context and put ContextData module to it
             WebFlowContext cc = restoreContext(context,Child);
             // a context name may have a suffix: .PC, .SC, or .AC. strip it
             String cDir = Child;
             int idx = Child.lastIndexOf(".");
             if(idx>-1) {
		 cDir = Child.substring(0,idx); 
             }  
             cDir = pDir+File.separator + cDir;
             System.out.println("cDir="+cDir);  
             sc.readContextData(cc,cDir);
             restoreChildren(cc);
	 }
     }
    }
    
  public WebFlowContext restoreContext(WebFlowContext p, String name){
    try {
    WebFlowContext c = WebFlowContextHelper.narrow(p.addNewContext(name));
    if(c==null) System.out.println("c is null");
    ContextData cdm = ContextDataHelper.narrow(c.addNewModule("ContextData"));
    if(cdm==null) System.out.println("--->cd is null");
    return c;
    } catch (Exception e) {
       System.out.println(e +"while createGatewayContext");
       return null;
    }  
  }


}




