package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.Base64.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import WebFlow.FB.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;
import java.net.*;

public class FileBrowser extends HttpServlet{
    
    org.omg.CORBA.Object o_base;
    public WebFlowContext master;
    public ORB orb;
    public BOA boa;
    ServletOutputStream out;
    ContextManager cm;
    private String userName; 
    private String option;
    private String problemName;
    private FBServer fb;
    org.omg.SecurityLevel2.SecurityManager security_manager=null;    
    String IorUrl="http://dev-spt01.asc.hpc.mil:8080/SciPortal/IOR/master.txt";
    String[] args;

    public void init(ServletConfig config) throws ServletException{
	super.init(config);
	userName="pierceme";
	args=new String[1];
	args[0]=userName;
	
	initializeORB(IorUrl);
	master=getMasterServer(IorUrl);
	fb=FBServerHelper.narrow(master.addNewModule("FileBrowser"));
	fb.test();
    }
    
    public void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {	
	out = res.getOutputStream();
	res.setContentType("text/html");
	
	printHead("FileBrowser");
	
	if(fb==null) {
	    System.err.println("FB object is null");
	    prnt("file browser is not available<br>");
	}
	
	else { 
	    
	    System.err.println("FB object found");
	    prnt("file browser attached<br>");
	    
	    String option = req.getParameter("method");
	    String filename = req.getParameter("filename");
	    
	    prnt(option+" "+filename);
	    
	    if(option==null) {
		prnt("no method given: no action!");
	    }
	    
	    else { 
		
		if(option.equals("checkforexist")) {
		    boolean t = fb.checkforexist(filename);
		    if(t) prnt("\nResponse:true"); else prnt("\nResponse:false");
		}
		
		if(option.equals("checkForDirectory")) {
		    boolean t = fb.checkForDirectory(filename);
		    if(t) prnt("\nResponse:true"); else prnt("\nRespone:false");
		}
		
		if(option.equals("getFileList")) {
		    out.print("\nResponse:");
		    String[] fl = fb.getFileList(filename);
		    for(int i=0; i<fl.length; i++) {
			out.print(fl[i]);
			out.print(" ");
			}
		    prnt("\nend");
		}
	    }
	
	out.println("</BODY>");    
	out.println("</HTML>");
	
	out.flush();
	out.close();
	}
	
    }
    
    public void initializeORB(String IorURL){
	try {
	    System.out.println("set system properties for ORBacus"); 
	    Properties props = System.getProperties();
	    props.put("org.omg.CORBA.ORBClass", "orbasec.ORB");
	    props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
	    System.setProperties(props);
	    
	    System.out.println("create ORB");
	    //
	    // Create client ORB 
	    //
	    
	    orb=org.omg.CORBA.ORB.init(args,props);
	    boa=((orbasec.ORB)orb).BOA_init(args,props);
	    
	    ///////////Added/////////////////////////////////////////////////
	    security_manager = 
		org.omg.SecurityLevel2.SecurityManagerHelper.narrow(
								    orb.resolve_initial_references("SecurityManager"));
	    
	    org.omg.SecurityLevel2.PrincipalAuthenticator pa;
	    pa = security_manager.principal_authenticator();
	    
	    String mechanism = "Kerberos";
	    String security_name="";
	    int method=orbasec.SecLev2.SecKerberosSession.value;
	    
	    orbasec.SecLev2.KerberosSession data=
		orbasec.corba.AuthUtil.default_KerberosSession();
	    data.config="FILE:/app/gateway/orbasec_krb5.conf";
	    data.cache_name="";
	    org.omg.CORBA.Any auth_data=orb.create_any();
	    orbasec.SecLev2.KerberosSessionHelper.insert(auth_data,data);
	    
	    org.omg.Security.SecAttribute privileges[] =
		new org.omg.Security.SecAttribute[0];
	    org.omg.SecurityLevel2.CredentialsHolder creds =
		new org.omg.SecurityLevel2.CredentialsHolder();
	    org.omg.CORBA.AnyHolder
		continuation_data =
		new org.omg.CORBA.AnyHolder(),
		auth_specific_data =
		new org.omg.CORBA.AnyHolder();
	    
	    pa.authenticate(
			    method,
			    mechanism,
			    security_name,
			    auth_data,
			    privileges,
			    creds,
			    continuation_data,
			    auth_specific_data
			    );
	    System.out.println("PrincipalAuthenticator ended");
	    
	}
	catch(SystemException ex) {
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
	
	catch(Exception ex1) {
	    System.err.println(ex1.getMessage());
	    ex1.printStackTrace();
	    System.exit(1);
	}
    }
    
    public WebFlowContext getMasterServer(String IorURL){
	WebFlowContext ws = null;
	try {
	    String masterIOR = getIORFromURL(IorURL);
	    o_base = orb.string_to_object(masterIOR);
	    ws = WebFlowContextHelper.narrow(o_base);
	}
	catch (Exception e) {System.out.println("getMasterServer: "+e);}
	return ws;
    }
    
    public String getIORFromURL(String urlString){
	String masterServerIOR="";
	String thisLine=null;
	try {
	    URL u = new URL(urlString);
	    try {
		DataInputStream theHTML = new DataInputStream(u.openStream());
		try {
		    while ((thisLine = theHTML.readLine()) != null) {
			masterServerIOR += thisLine;
		    } 
		} 
		catch (Exception e) {
		    System.out.println("getIORfromURL:"+e);
		}
	    } 
	    catch (Exception e) {
		System.out.println("getIORfromURL:"+e);
	    }
	    
	} 
	catch (MalformedURLException e) {
	    System.out.println("getIORfromURL:"+urlString + " is not a parseable URL");
	    System.out.println("getIORfromURL:"+e);
	}
	return masterServerIOR;
    }
    
    public void printHead(String title) {
	prnt("<html>");
	prnt("<TITLE>");
	prnt(title);
	prnt("\t</TITLE>");
	prnt("</HEAD>");
	prnt("<BODY STYLE=\"color:black;\" BGCOLOR=\"#f2fae4\" BACKGROUND=\"/SciPortal/ccmImages/bg1x.jpg\">");
	prnt("<H1 ALIGN=\"center\">"+title+"</H1>");
    }
    
    
    public void prnt(String msg){
	try{
	    out.println(msg);
	} catch (Exception e){System.out.println(e);}
    }
    
    public String formatDate(String d){
	Date dateD=null;
	long dateL;
	SimpleDateFormat formatter = new SimpleDateFormat("s",Locale.getDefault());
	try {
	    dateL = (new Long(d)).longValue();
	    dateD = new Date(dateL);
	    formatter.applyPattern("yyyy-MMM-d HH:mm:ss");
	} catch (Exception e) {System.out.println(e);}
	String dateS = formatter.format(dateD);
	return dateS;  
    }
    
    public String getServletInfo(){
	return "By T. Haupt and K. Flurchick";
    }
    
}



