import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
                   
/* This servlet takes the argument CookieID=kerberosID+Date and uses it to
 * set the value of the cookie for the client.
 */
            
public class SessionTest extends HttpServlet
{
    PrintWriter out;
    
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException
    {
	doPost(req,res);
    }

    protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException 
    {
	System.out.println("Servlet excuting");  	

	res.setContentType("text/html");
	PrintWriter out=res.getWriter();

	HttpSession session=req.getSession(true);
	Integer count=(Integer)session.getValue("snoop.count");
	if(count==null)
	    count=new Integer(1);
	else
	    count=new Integer(count.intValue()+1);
	session.putValue("snoop.count",count);
	
	out.println("<html><head><title>SessionTest</title></head>");
	out.println("<body><h1>SessionTest</h1>");
	
	out.println("You've visited this page "+count + ((count.intValue()==1)?" time." : " times."));

	out.println("<p>");

	out.println("<h3>Here is your saved session data:</h3>");
	String[] names=session.getValueNames();
	for (int i=0;i<names.length;i++) {
	    out.println(names[i]+": "+session.getValue(names[i])+"<br>");
	}
	
	out.println("<h3>Here are some vital stats on your session:</h3>");
	out.println("Session id: "+session.getId()+"<BR>");
	out.println("New Session: "+session.isNew()+"<BR>");
	out.println("Creation Time: "+session.getCreationTime());
	out.println("<I>("+new Date(session.getCreationTime())+")</i><br>");
	out.println("Last access time: "+session.getLastAccessedTime());
	out.println("<i>("+new Date(session.getLastAccessedTime())+")</i><br>");
	
	out.println("Requested session ID from cookie: "+
		    req.isRequestedSessionIdFromCookie()+"<BR>");
	out.println("Requested session ID from URL: "+
		    req.isRequestedSessionIdFromUrl()+"<BR>");
	out.println("Requested session ID valid: "+
		    req.isRequestedSessionIdValid()+"<BR>");
	
	out.println("<h3>Here are all current session IDs");
	out.println("and the times they've hit this page:</h3>");
	HttpSessionContext context=session.getSessionContext();
	Enumeration ids=context.getIds();
	while(ids.hasMoreElements()) {
	    String id=(String)ids.nextElement();
	    out.println(id+": ");
	    HttpSession foreignSession=context.getSession(id);
	    Integer foreignCount=
		(Integer)foreignSession.getValue("snoop.count");
	    if(foreignCount==null)
		out.println(0);
	    else
		out.println(foreignCount.toString());
	    out.println("<br>");
	}
	
	out.println("<h3>Test URL Rewriting</h3>");
	out.println("Click <a href=\""+res.encodeUrl(req.getRequestURI())+"\">here</a>");
	out.println("to test that session tracking works via URL");
	out.println("rewriting even when cookies aren't supported.");


	out.println("<body></html>");

    }
    
}




