package hello;

import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import orbasec.corba.Opaque;

import javax.servlet.*;
import javax.servlet.http.*;

public class ClientServlet extends HttpServlet {
    PrintWriter out;
    String[] args;

    //
    // Standalone program initialization
    //
    protected void doGet(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	
        doPost(req, res);
    }
    
    protected void doPost(HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {
	System.out.println("start servlet");
	args=new String[1];
	args[0]="nothing";
	
	out = res.getWriter();
	res.setContentType("text/html");
	out.println("<head>");
	out.println("<title>startMM</title>"); 
	
	out.println("</head>");
	out.println("<body bgcolor=\"white\">");
	out.println("<center>");
	out.println("<h3> startMM</h3>");
	out.println("</center>");
	out.println("<p>");
	out.println("WebFlow server is starting now...(1)");
	out.println("</body>");    
	out.println("</html>");
	System.out.println("about to flush");
	out.flush();
	out.close();

	
    	try {
	    //
	    // ORB and SL2 initialization
	    //
	    java.util.Properties properties = new java.util.Properties();
	    orbasec.SL2.init( args, properties );
	    ORB orb = orbasec.SL2.orb();
	    
	    // 
	    // Get SecurityLevel2::Current from ORB
	    // 
	    org.omg.SecurityLevel2.Current current = 
		org.omg.SecurityLevel2.CurrentHelper.narrow(
							    orb.resolve_initial_references("SecurityCurrent"));
	    
	    //
	    // Authenticate using PrincipalAuthenticator
	    //
	    org.omg.SecurityLevel2.PrincipalAuthenticator pa;
	    pa = current.principal_authenticator();
	    
	    String  mechanism = "Kerberos";
	    int	    method    = 0;
	    byte	security_name[] = 
		new byte[0];
	    //				    Opaque.encodeKerberosName(
	    //@@@@ Change this to a valid kerberos principal!
	    //				          "bart@MYREALM.COM"
	    //					).getEncoding();
	    
	    byte	auth_data[] =
		(
		 //@@@@ Change this to  User Principal Password!
		 //				     "password=\"mypassword\"\n" +
		 //@@@@ Setting delegation capability off	
		 "delegation=false\n" +
		 //@@@@ Using a memory credentials cache
//				     "cache_name=MEMORY:0\n" +
		 //@@@@ Kerberos configuration file
		 "config=FILE:/app/gateway/orbasec_krb5.conf\n"
		 ).getBytes();
	    
	    org.omg.Security.SecAttribute privileges[] =
		new org.omg.Security.SecAttribute[0];
	    org.omg.SecurityLevel2.CredentialsHolder creds =
		new org.omg.SecurityLevel2.CredentialsHolder();
	    org.omg.Security.OpaqueHolder
		continuation_data =
		new org.omg.Security.OpaqueHolder(),
		auth_specific_data =
		new org.omg.Security.OpaqueHolder();
	    
	    pa.authenticate(
			    method,
			    mechanism,
			    security_name,
			    auth_data,
			    privileges,
			    creds,
			    continuation_data,
			    auth_specific_data
			    );
	    
	    //
	    // Print credentials to screen
	    //
	    org.omg.SecurityLevel2.Credentials[] credlist = 
		current.own_credentials();
	    System.out.println("Own Credentials:");
	    orbasec.corba.CredUtil.dumpCredentials(credlist);
	    
	    org.omg.CORBA.Policy[] policies = null;
	    
	    // 
	    // Get "hello" object
	    //
	    System.out.println("Getting Hello Reference");
	    String ref = null;
	    try {
		String refFile = "/app/gateway/krb-hello/Hello.ref";
		FileInputStream file = new FileInputStream(refFile);
		BufferedReader in =
		    new BufferedReader(new InputStreamReader(file));
		ref = in.readLine();
		file.close();
	    } catch(IOException ex) {
		System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }
	
	    System.out.println("Got ref, now narrowing Hello");
	    org.omg.CORBA.Object obj = orb.string_to_object(ref);
	    if(obj == null)
		throw new RuntimeException();
	    
	    Hello hello = HelloHelper.narrow(orb.string_to_object(ref));
	    if(hello == null)
		throw new RuntimeException();
	    
	    System.out.println("Hello's Credentials:");
	    orbasec.corba.CredUtil.dumpCredentials(
						   current.get_target_credentials(hello));

	    System.out.println("Call remote hello object.");
	    hello.hello();
    	} 
	catch(Exception ex) {
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
    	}
	
    }
}

