//tabstop=4
//*****************************************************************************/
// Project: ORBAsec
//
// File:    Server.java
// Date:    August 1998
//
// Description:
//              This file is a modification of ORBacus 3.0 hello demo modified
//   to illustrate Adiron's ORBAsec SL2 (SecurityLevel2).  
//
// -------------------------------------------------------------------------
// Copyright (C) 1998 Polar Humenn
//                    All rights reserved.
// -------------------------------------------------------------------------
// $Id$
//*****************************************************************************/
// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package hello;

import org.omg.CORBA.*;
import java.io.*;
import orbasec.corba.Opaque;

public class Server
{
	public static void main(String args[])
	{
		try {
			//
			// ORB, BOA, and SL2 initialization
			//
			java.util.Properties properties = new java.util.Properties();
			orbasec.SL2.init_with_boa( 
				args, properties, properties );
			ORB orb = orbasec.SL2.orb();
			BOA boa = orbasec.SL2.boa();

    		// 
    		// Get SecurityLevel2::Current from ORB
    		// 
    		org.omg.SecurityLevel2.Current current = 
			org.omg.SecurityLevel2.CurrentHelper.narrow(
	    		orb.resolve_initial_references("SecurityCurrent"));

    		//
    		// Authenticate using PrincipalAuthenticator
    		//
    		org.omg.SecurityLevel2.PrincipalAuthenticator pa;
    		pa = current.principal_authenticator();

			String  mechanism = "Kerberos";
			int	    method    = 0;
			
			byte	security_name[] =
				    Opaque.encodeKerberosName(
//@@@@@ Change this to a vaild kerberos principal name 
				         "gateway/dev-spt01.asc.hpc.mil@tade.asc.hpc.mil"
					).getEncoding();
					
			byte	auth_data[] =
			        (
//@@@@ Credentials will not have delegation ability.
					 "delegation=false\n" +
//@@@@ Using a memory credentials cache.
				     "keytab=FILE:/app/gateway/dev-spt01.gateway.keytab\n" +
					 "enable_server=true\n" +
//@@@@ Kerberos configuration file
					 "config=FILE:/app/gateway/orbasec_krb5.conf\n"
					 ).getBytes();

			org.omg.Security.SecAttribute privileges[] =
				new org.omg.Security.SecAttribute[0];
			org.omg.SecurityLevel2.CredentialsHolder creds_holder =
				new org.omg.SecurityLevel2.CredentialsHolder();
			org.omg.Security.OpaqueHolder
			 continuation_data =
				new org.omg.Security.OpaqueHolder(),
			 auth_specific_data =
				new org.omg.Security.OpaqueHolder();

			pa.authenticate(
				method,
				mechanism,
				security_name,
				auth_data,
				privileges,
				creds_holder,
				continuation_data,
				auth_specific_data
			);

			//
			// Print credentials to screen
			//
			org.omg.SecurityLevel2.Credentials[] credlist = 
				current.own_credentials();
			System.out.println("Own Credentials:");
			orbasec.corba.CredUtil.dumpCredentials(credlist);

			// Uncomment to experiment with Server Acception Options
/* *
			// Modify Accepting Options
			org.omg.SecurityLevel2.Credentials creds = 
				credlist[0];  // creds_holder.value should be the same
			
			// Turn off EstablishTrustInTarget requirement
			creds.accepting_options_required( (short) 
				(creds.accepting_options_required() |
				 org.omg.Security.EstablishTrustInTarget.value));
			
			// Turn off Confidentiality support
			creds.accepting_options_supported( (short) 
				(creds.accepting_options_supported() &
				 ~org.omg.Security.NoProtection.value));
			
			System.out.println("Own Credentials after modification:");
			orbasec.corba.CredUtil.dumpCredentials(credlist);
/* */
			//
			// Create implementation object
			//
			Hello_impl p = new Hello_impl();
			p.orb        = orb;

			//
			// Save reference
			//
			try {
				String ref = orb.object_to_string(p);
				String refFile = "Hello.ref";
				FileOutputStream file = new FileOutputStream(refFile);
				PrintWriter out = new PrintWriter(file);
				out.println(ref);
				out.flush();
				file.close();
			} catch(IOException ex) {
				System.err.println("Can't write to `" +
						   ex.getMessage() + "'");
				System.exit(1);
			}

			System.out.println("\nHello Server is Ready.");
			
			//
			// Run implementation
			//
			boa.impl_is_ready(null);

			System.exit(0);
		} catch(Exception ex) {
			System.err.println(ex.getMessage());
			ex.printStackTrace();
			System.exit(1);
		}
	}
}
