package extensions.generic;

import com.ibm.xml.*;
import com.ibm.xml.parser.*;
import com.ibm.xml.parsers.*;
import java.io.*;
import java.util.*;
import java.text.*;
import org.w3c.dom.*;
import com.ibm.xml.framework.*;

public class parseGOW {

    Vector keyVec = new Vector(); // keyVec is the key vector.
    Vector valueVec = new Vector(); // valueVec is the value vector.
    String value = null;
    Hashtable hash = new Hashtable();
    parseXMLBean parseXML;

    public parseGOW() {
    }
    
    public void setXML(parseXMLBean parseXML) {
	this.parseXML = parseXML;
    }

    public int doParse(String xmlfilename){
	String key = null, value = null;
	String tagID = null;
	int nApplications = 0;

        if (xmlfilename == null) {
            System.out.println("Missing xmlfilename.");
            return nApplications;
        }
        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);

            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
                return(2);
            }
 
	    // Document is well-formed
            Document doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();

            Vector outerXSILTag = getAllTags(elem, "XSIL");
	    nApplications = outerXSILTag.size();
	    System.out.println("The number of the outer XSIL: "+nApplications);
	    removeWhiteSpaceNodes(elem);
	    
	    Node nextnode = elem.getFirstChild();
	    Vector inXSILTags = getAllTags(nextnode, "XSIL");
	    nApplications = inXSILTags.size();
	    removeWhiteSpaceNodes((Element)nextnode);
	    
	    NodeList nodelist = elem.getChildNodes();
	    buildNodes(nodelist, tagID);
        } catch (Exception e) {
            e.printStackTrace();
        }
	// Make the hash table from the name/value pairs.
	for(int i = 0; i < keyVec.size(); i++){
	    hash.put(keyVec.get(i), (valueVec.get(i) + "+"));
	}
	//System.out.println("Hash Table = " + hash.toString());
	return nApplications;
    }

    
    public boolean removeApplication(String xmlfilename, String applName) {
	String tagID = null;
	boolean status = false;
	Document doc = null;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);

            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
		status = false;
                return status;
            }
            
	    // Document is well-formed	    
            doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(elem);

	    /*
	    NodeList nodelist = elem.getChildNodes();
	    buildNodes(nodelist, tagID);
	    */

	    Node nextnode = elem.getFirstChild();
	    removeWhiteSpaceNodes((Element)nextnode);

	    Vector inXSILTags = getAllTags(nextnode, "XSIL");

	    int nAppl = inXSILTags.size();
	    for (int j = 0; j < nAppl; j++) {
		Node applNode = (Node)inXSILTags.elementAt(j);
		if( ((Element)applNode).getAttribute("Name").equals(applName)){
		    nextnode.removeChild(applNode);
		    status = true;
		}
	    }
	} catch (Exception e) {
	    System.out.println(e+" while removing the application" );
	    status = false;
	}

	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			  new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.out.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }


    /* 
       Hahtable (key/value)
       ===================
       key        |  value
       ===================
       applName   |
       -------------------
       paramInNum |
       -------------------
       infileNum  |
       -------------------
       paramOutNum |
       -------------------
       outfileNum |
       -------------------
       iostyle    |
       -------------------
       hostName   |
       -------------------
       oldhostName |
       -------------------
       queueType  |
       -------------------
       execPath   |
       -------------------
       workDir    |
       -------------------
       qsubPath   |
       -------------------
       classPath   |
       -------------------
       vizName    |
       -------------------
       vizHost    |
       -------------------
       vizPath    |
       -------------------
       other stuffs| Table
       ===================
    */
    
    public boolean addApplication(String xmlfilename, Hashtable applData,
				  boolean addflag) {
	boolean status = false;
	Document doc = null;  //new TXDocument();
	//Document doc = new Document();
	Element item, itemA, itemB, itemC;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);
	    
            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
		status = false;
                return status;
            }

            // Document is well-formed
            doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(elem);

	    Node nextnode = elem.getFirstChild();
	    removeWhiteSpaceNodes((Element)nextnode);

	    //  Make <User> element and add it
	    //  as a child of root
	    item = doc.createElement("XSIL");
	    item.setAttribute("Name",(String)applData.get("applName"));
	    item.setAttribute("Type","generic.parseXMLDesc");
	    
	    System.out.println("XSIL: "+(String)applData.get("applName"));

	    // Make <userID> element and add it
	    // as a child of User
	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfInParams");

	    itemA.appendChild(doc.createTextNode((String)applData.get("paramInNum")));
	    item.appendChild(itemA);

	    System.out.println("paramInNum: "+(String)applData.get("paramInNum"));


	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfInFiles");

	    itemA.appendChild(doc.createTextNode((String)applData.get("infileNum")));
	    item.appendChild(itemA);

	    System.out.println("inFileNum: "+(String)applData.get("infileNum"));
	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfOutParams");

	    itemA.appendChild(doc.createTextNode((String)applData.get("paramOutNum")));
	    item.appendChild(itemA);
	    System.out.println("paramOutNum: "+(String)applData.get("paramOutNum"));

	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","NumberOfOutFiles");

	    itemA.appendChild(doc.createTextNode((String)applData.get("outfileNum")));
	    item.appendChild(itemA);
	    System.out.println("outfileNum: "+(String)applData.get("outfileNum"));

	    itemA = doc.createElement("Param");
	    itemA.setAttribute("Name","IOStyle");

	    itemA.appendChild(doc.createTextNode((String)applData.get("iostyle")));
	    item.appendChild(itemA);
	    System.out.println("iostyle: "+(String)applData.get("iostyle"));

	    //Host Name
            String hostName = (String)applData.get("hostName");
            String oldhostName = (String)applData.get("oldhostName");
            String queueType = (String)applData.get("queueType");
            String execPath = (String)applData.get("execPath");
            String workDir = (String)applData.get("workDir");
            String qsubPath = (String)applData.get("qsubPath");
	    String classPath = (String)applData.get("classPath");

	    System.out.println("hostName: "+hostName);
	    System.out.println("queueType: "+queueType);
	    System.out.println("execPath: "+execPath);
	    System.out.println("workDir: "+workDir);
	    System.out.println("qsubPath: "+qsubPath);
	    System.out.println("classPath: "+classPath);


	    StringTokenizer sthostname = new StringTokenizer(hostName,"+");
	    StringTokenizer stoldhostname = new StringTokenizer(oldhostName,"+");
	    StringTokenizer stqueuetype = new StringTokenizer(queueType,"+");
	    StringTokenizer stexecpath = new StringTokenizer(execPath,"+");
	    StringTokenizer stworkdir = new StringTokenizer(workDir,"+");
	    StringTokenizer stqsubpath = new StringTokenizer(qsubPath,"+");
	    StringTokenizer stclasspath = new StringTokenizer(classPath,"+");

	    while(sthostname.hasMoreTokens()) {
		//System.out.println("has more tokens");
		String hntoken = sthostname.nextToken();
		String oldhntoken = stoldhostname.nextToken();
		String qttoken = stqueuetype.nextToken();
		String eptoken = stexecpath.nextToken();
		String wdtoken = stworkdir.nextToken();
		String qptoken = stqsubpath.nextToken();
		String cptoken = stclasspath.nextToken();
		System.out.println("hntokens: "+hntoken);
		System.out.println("qttokens: "+qttoken);
		System.out.println("eptokens: "+eptoken);
		System.out.println("wdtokens: "+wdtoken);
		System.out.println("qptokens: "+qptoken);
		System.out.println("cptokens: "+cptoken);


		int index = hntoken.indexOf(".");
		String xsilhostname = hntoken.substring(0,index);
		System.out.println("xsilhostname: "+xsilhostname);


		itemA = doc.createElement("XSIL");
		itemA.setAttribute("Name",xsilhostname);
		itemA.setAttribute("Type","generic.parseXMLHost");	    
		System.out.println("XSIL: "+itemA);

		itemB = doc.createElement("Param");
		itemB.setAttribute("Name","HostName");

		itemB.appendChild(doc.createTextNode(hntoken));
		itemA.appendChild(itemB);
		System.out.println("HostName: "+itemB);

		itemB = doc.createElement("Param");
		itemB.setAttribute("Name","QueueType");

		itemB.appendChild(doc.createTextNode(qttoken));
		itemA.appendChild(itemB);
		System.out.println("QueueType: "+itemB);

		itemB = doc.createElement("Param");
		itemB.setAttribute("Name","ExecPath");

		itemB.appendChild(doc.createTextNode(eptoken));
		itemA.appendChild(itemB);
		System.out.println("ExecPath: "+itemB);

		itemB = doc.createElement("Param");
		itemB.setAttribute("Name","WorkDir");

		itemB.appendChild(doc.createTextNode(wdtoken));
		itemA.appendChild(itemB);
		System.out.println("WorkDir: "+itemB);

		itemB = doc.createElement("Param");
		itemB.setAttribute("Name","QsubPath");

		itemB.appendChild(doc.createTextNode(qptoken));
		itemA.appendChild(itemB);
		System.out.println("QsubPath: "+itemB);

		itemB = doc.createElement("Param");
		itemB.setAttribute("Name","CLASSPATH");

		itemB.appendChild(doc.createTextNode(cptoken));
		itemA.appendChild(itemB);
		System.out.println("classPath: "+itemB);

		//Table Construction	
		if(!addflag) {
		    Hashtable hash=parseXML.getEnvironHash((String)applData.get("applName"),oldhntoken);	
		    if(hash.size() != 0) {

			itemB = doc.createElement("Table");
			Enumeration en=hash.keys();
			while(en.hasMoreElements()) {
			    String key=(String)en.nextElement();
			    itemC = doc.createElement("Column");
			    itemC.setAttribute("Name",key);
			    itemC.setAttribute("Type","string");
			    itemB.appendChild(itemC);
			    //System.out.println("Column: "+itemB);

			}
			itemC = doc.createElement("Stream");
			itemC.setAttribute("Delimiter",",");
		
			String streamData = "";
			en=hash.keys();
			while(en.hasMoreElements()) {
			    String key1=(String)en.nextElement();
			    String key11 = oldhntoken+"+"+key1;
			    streamData +=(String)applData.get(key11)+",";
			}
			int index1 =streamData.lastIndexOf(",");
			streamData = streamData.substring(0,index1);

			itemC.appendChild(doc.createTextNode(streamData));
			itemB.appendChild(itemC);
			itemA.appendChild(itemB);
			item.appendChild(itemA); 
		    } else {
			item.appendChild(itemA); 
		    }		
		} else {
		    item.appendChild(itemA); 
		}
	    }


	    if(!addflag) {
		String vizName = (String)applData.get("vizName");
		String vizHost = (String)applData.get("vizHost");
		String vizPath = (String)applData.get("vizPath");

		StringTokenizer stvizname = new StringTokenizer(vizName,"+");
		StringTokenizer stvizhost = new StringTokenizer(vizHost,"+");
		StringTokenizer stvizpath = new StringTokenizer(vizPath,"+");

		while(stvizname.hasMoreTokens()) {
		    String vntoken = stvizname.nextToken();

		    itemA = doc.createElement("XSIL");
		    itemA.setAttribute("Name",vntoken);
		    itemA.setAttribute("Type","generic.parseXMLViz");	    
		    
		    itemB = doc.createElement("Param");
		    itemB.setAttribute("Name","VizName");

		    itemB.appendChild(doc.createTextNode(vntoken));
		    itemA.appendChild(itemB);
		    
		    itemB = doc.createElement("Param");
		    itemB.setAttribute("Name","VizHostName");

		    itemB.appendChild(doc.createTextNode(stvizhost.nextToken()));
		    itemA.appendChild(itemB);

		    itemB = doc.createElement("Param");
		    itemB.setAttribute("Name","VizPath");

		    itemB.appendChild(doc.createTextNode(stvizpath.nextToken()));
		    itemA.appendChild(itemB);
		    item.appendChild(itemA);	    
		}
	    }

	    nextnode.insertBefore((Node)item, null);
	    status = true;
	} catch (Exception e) {
	    System.out.println(e+" while adding the application" );
	    status = false;
	}
	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			   new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.out.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }

    public boolean modifyHostname(String xmlfilename, String applName, Hashtable tableData) {
	boolean status = false;
	Document doc = null;
	Element itemA,itemB;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);

            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
		status = false;
                return status;
            }
            
	    // Document is well-formed	    
            doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(elem);

	    Node nextnode = elem.getFirstChild();    //XSIL application list
	    removeWhiteSpaceNodes((Element)nextnode);

	    //find "applicatin" node
	    Node applNode = null;
	    for(applNode = nextnode.getFirstChild(); applNode!=null;
		applNode = applNode.getNextSibling()) {
		if(applNode instanceof Element) {
		    if(((Element)applNode).getAttribute("Name").equals(applName)) {
			System.out.println("Node Name Tag: "+applNode.getNodeName());
			System.out.println("Attribute: "+((Element)applNode).getAttribute("Name"));
			break;
		    }
		}
	    }
	    removeWhiteSpaceNodes((Element)applNode);

	    String hostName = (String)tableData.get("hostName");
	    String queueType = (String)tableData.get("queueType");
	    String execPath = (String)tableData.get("execPath");
	    String workDir = (String)tableData.get("workDir");
	    String qsubPath = (String)tableData.get("qsubPath");
	    String classPath = (String)tableData.get("classPath");

	    int index = hostName.indexOf(".");
	    String xsilhostname = hostName.substring(0,index);

	    itemA = doc.createElement("XSIL");
	    itemA.setAttribute("Name",xsilhostname);
	    itemA.setAttribute("Type","generic.parseXMLHost");	    

	    itemB = doc.createElement("Param");
	    itemB.setAttribute("Name","HostName");

	    itemB.appendChild(doc.createTextNode(hostName));
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Param");
	    itemB.setAttribute("Name","QueueType");

	    itemB.appendChild(doc.createTextNode(queueType));
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Param");
	    itemB.setAttribute("Name","ExecPath");

	    itemB.appendChild(doc.createTextNode(execPath));
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Param");
	    itemB.setAttribute("Name","WorkDir");

	    itemB.appendChild(doc.createTextNode(workDir));
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Param");
	    itemB.setAttribute("Name","QsubPath");
	    
	    itemB.appendChild(doc.createTextNode(qsubPath));
	    itemA.appendChild(itemB);

	    itemB = doc.createElement("Param");
	    itemB.setAttribute("Name","CLASSPATH");

	    itemB.appendChild(doc.createTextNode(classPath));
	    itemA.appendChild(itemB);

	    applNode.insertBefore((Node)itemA, null);
	    status = true;

	} catch (Exception e) {
	    System.out.println(e+" while modifying the application" );
	    status = false;
	}

	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			  new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.out.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }

    public boolean removeHostname(String xmlfilename, String applName, Hashtable tableData) {
	boolean status = false;
	Document doc = null;
	Element itemA,itemB;

        try {
            // Open XML file
            FileInputStream is = new FileInputStream(xmlfilename);

            // Start parsing
            Parser parser = new Parser(xmlfilename);

            // Check if there is errors
            if (parser.getNumberOfErrors() > 0) {
		System.out.println("Errors > zero");
		status = false;
                return status;
            }
            
	    // Document is well-formed	    
            doc = parser.readStream(is);
            Element elem = doc.getDocumentElement();
	    removeWhiteSpaceNodes(elem);

	    Node nextnode = elem.getFirstChild();    //XSIL application list
	    removeWhiteSpaceNodes((Element)nextnode);

	    //find "application" node
	    Node applNode = null;
	    for(applNode = nextnode.getFirstChild(); applNode!=null;
		applNode = applNode.getNextSibling()) {
		if(applNode instanceof Element) {
		    if(((Element)applNode).getAttribute("Name").equals(applName)) {
			System.out.println("Node Name Tag: "+applNode.getNodeName());
			System.out.println("Attribute: "+((Element)applNode).getAttribute("Name"));
			break;
		    }
		}
	    }
	    removeWhiteSpaceNodes((Element)applNode);

	    String hostName = (String)tableData.get("hostName");
	    int index = hostName.indexOf(".");
	    String xsilhostname = hostName.substring(0,index);

	    //find "host" node
	    Node hostNode = null;
	    for(hostNode = applNode.getFirstChild(); hostNode!=null;
		hostNode = hostNode.getNextSibling()) {
		if(hostNode instanceof Element) {
		    if(((Element)hostNode).getAttribute("Name").equals(xsilhostname)) {
			applNode.removeChild(hostNode);
			status = true;
			break;
		    }
		}
	    }
	    //removeWhiteSpaceNodes((Element)hostNode);


	} catch (Exception e) {
	    System.out.println(e+" while removing the application" );
	    status = false;
	}

	// Save the XML document
	try{
	    PrintWriter xmlFileOut = new PrintWriter(
			  new FileWriter(xmlfilename, false));
	    ((TXDocument)doc).printWithFormat(xmlFileOut);
	} catch(IOException e){
	    System.out.println("Error opening xmlFileOut.");
	    System.exit(0);
	}
	return status;
    }

    public void removeWhiteSpaceNodes(Element parent) {
	Node nextNode = parent.getFirstChild();
        for (Node child = parent.getFirstChild(); nextNode != null;) {
	    child = nextNode;
	    nextNode = child.getNextSibling();
	    
            if (child instanceof TXText){
		if(((TXText)child).getIsIgnorableWhitespace()){
		    parent.removeChild(child);
		}
            } else if(child instanceof TXElement){
		removeWhiteSpaceNodes((Element)child);
	    }
	}
    }


    public void buildNodes(NodeList nl, String tagID){
	int indexnl = 0;
	boolean found = false;
	//System.out.println("Node Length: "+nl.getLength());

	while(indexnl < (nl.getLength())){
	    Node childNL = nl.item(indexnl);
	    String childName = childNL.getNodeName();
	    System.out.println("Node Name: "+childName);

	    if(childName != "#text") {
		//System.out.println("Attribute Name: "+((Element)childNL).getAttribute("Name"));
		//System.out.println("Attribute Type: "+((Element)childNL).getAttribute("Type"));
		tagID = childName;
	    }
	    String childValue = childNL.getNodeValue();
	    if (childNL instanceof TXText) {
		childValue = childNL.getNodeValue();
		System.out.println("Node Value: "+childValue);
	    } else if (childNL.hasChildNodes()){
		NodeList nextnodelist = childNL.getChildNodes();
		buildNodes(nextnodelist, tagID);
	    }
	    indexnl++;
	    if((tagID != null) && (childValue != null)) {
		if(keyVec.isEmpty() == true){
		    keyVec.addElement(tagID);
		    valueVec.addElement(childValue);
		    found = false;
		} else if(keyVec.isEmpty() != true){
		    for(int i = 0; i < keyVec.size(); i++){
			if (tagID.equals(keyVec.get(i))){
			    found = true;
			    value = (String)valueVec.get(i);
			    value = value + "+" + childValue;
			    valueVec.setElementAt(value, i);
			    break;
			}
		    }
		    if(found == false) {
			keyVec.addElement(tagID);
			valueVec.addElement(childValue);
			found = false;
		    }
		}
	    }
	}
    }
    

    private Vector getAllTags(Node node, String tag) {
	Vector result=new Vector();
	
	for(Node ch = node.getFirstChild(); ch!=null;
	    ch = ch.getNextSibling()) {
	    if(ch instanceof Element) {
		if(ch.getNodeName().equals(tag)) {
		    result.addElement(ch);
		    System.out.println("Node Name Tag: "+ch.getNodeName());
		    System.out.println("Attribute: "+((Element)ch).getAttribute("Name"));
		}
	    }
	}
	return result;
    }
}


