/**
 * This file extracts parameter values of the XSIL Viz tag.
 */ 
package extensions.generic;
import org.escience.XSIL.*;
import java.util.*;

public class parseXMLViz extends XSIL {

    public String vizname;
    public String vizpath;
    public String vizhostname;
    
    boolean instantiated = false;
    
    public void construct(){	

	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
		Param p = (Param)x;
		if(p.getName().equals("VizName"))
		    vizname = p.getText();
		if(p.getName().equals("VizHostName"))
		    vizhostname=p.getText();
		if(p.getName().equals("VizPath"))
		    vizpath = p.getText();
	    }
	}
    }

    // This function does the heavy lifting of reading arrays and so on
    // It is separate from the construction because it is not called 
    // unless necessary.

    public void instantiate(){
	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
		Param p = (Param)x;
		if(p.getName().equals("VizName"))
		    vizname = p.getText();
		if(p.getName().equals("VizHostName"))
		    vizhostname=p.getText();
		if(p.getName().equals("VizPath"))
		    vizpath = p.getText();
	    }
	}
    }
     
    public String getVizHost() { 
	return vizhostname; 
    }
    public String getVizName() { 
	return vizname; 
    }
    public String getVizpath() { 
	return vizpath; 
    }
}
