/**
 * Program Name: scriptFactory.java
 * Comments: This class contains a factory method for creating a specific
 * subclass of the createScript class.  For example, for PBS, there should
 * be a class createPBS, which we can create by
 *                scriptFactory.makeChild("PBS",cm)
 * where the first argument can be obtained from the ApplDesc.xml file and 
 * the second is an instance of the context manager class.
 */

package extensions.generic;
import WebFlow.*;
import WebFlow.ContextManager.*;

public class scriptFactory {
    public static createScript makeChild(String queueType, 
					 ContextManager cm,String name) {
	createScript thisScript=null;	
	String userName=name;
	String viz;

	if (queueType.equalsIgnoreCase("PBS")) {
	    thisScript=new createPBS(cm,userName);
	}
	else if(queueType.equalsIgnoreCase("DQS")) {
	    thisScript=new createDQS(cm,userName); 
	}
	else if(queueType.equalsIgnoreCase("VIZ")) {

	    viz = cm.getCurrentSessionProperty("VtkCode");
	    if(viz.equalsIgnoreCase("gnuplot")) {
		viz = "script.gnu";
		thisScript=new createVIZ(cm,userName,viz);
	    } 
	    else viz = "script.matlab";
	    //viz = "script.gnu";
	}
	else 
	    System.err.println("Queue not supported.");
	return thisScript;
    }
}
