/**
 * Program Name: setPropBean.java
 * Comments: Store information needed to construct
 * the queue script from the request Object
 */

package extensions.generic;

import java.util.*;
import java.io.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.ContextManager.*;

public class setPropBean {

    //public static String filepath = "/a/birch.csit.fsu.edu/shared/home/cyoun/GATEWAY/apache1.3.12/WWW/GOW/WEB-INF/src/generic/param.bin";
    ContextManager cm;
    parseXMLBean parseXML;
    jobInfoBean storeInfo;
    nameEncodeBean nameEncode;
    boolean codenameflag = false;
    boolean machinenameflag = false;

    public setPropBean() {
	//Empty constructor
    }

    public void setXML(parseXMLBean parseXML) {
	this.parseXML = parseXML;
    }

    public void setCM(ContextManager cm) {
	this.cm = cm;
    }

    public void setSI(jobInfoBean storeInfo) {
	this.storeInfo = storeInfo;
    }

    public void setNE(nameEncodeBean nameEncode) {
	this.nameEncode = nameEncode;
    }

    public void setRequests(HttpServletRequest request){
	String paramName = null;
	String paramValue = null;
	Enumeration requestNames = request.getParameterNames();
	while(requestNames.hasMoreElements()) {
	    paramName = (String)requestNames.nextElement();
	    paramValue = request.getParameter(paramName);
	    if(paramName.equals("codeName")) {
		codenameflag = true;
		cm.setCurrentSessionProperty(paramName,paramValue);
	    }
	    else if(paramName.equals("machineName")) {
		machinenameflag = true;
		cm.setCurrentSessionProperty(paramName,paramValue);
	    }
	    else {
		cm.setCurrentSessionProperty(paramName,paramValue);	    
	    }
	    //System.out.println("paramName: "+paramName+";paramValue: "+paramValue);
	}

	if(codenameflag && machinenameflag) {
	    String code = cm.getCurrentSessionProperty("codeName");
	    String machine = cm.getCurrentSessionProperty("machineName"); 

	    String execpath=
		parseXML.getMatchTag(code, machine,"ExecPath");
	    cm.setCurrentSessionProperty("execpath",execpath);

	    String qsubpath=
		parseXML.getMatchTag(code, machine,"QsubPath");
	    cm.setCurrentSessionProperty("qsubpath",qsubpath);

	    String queueType=
		parseXML.getMatchTag(code, machine,"QueueType");
	    cm.setCurrentSessionProperty("QueueType",queueType);

	    String NumOfInParams=
		parseXML.getNumberOfInParams(code);
	    cm.setCurrentSessionProperty("NumInParams",NumOfInParams);

	    String NumOfInFiles=
		parseXML.getNumberOfInFiles(code);
	    cm.setCurrentSessionProperty("NumInFiles",NumOfInFiles);

	    String NumOfOutParams=
		parseXML.getNumberOfOutParams(code);
	    cm.setCurrentSessionProperty("NumOutParams",NumOfOutParams);
                                                                     
	    String NumOfOutFiles=
		parseXML.getNumberOfOutFiles(code);
	    cm.setCurrentSessionProperty("NumOutFiles",NumOfOutFiles);

	    String iostyle=parseXML.getIOStyle(code);
	    cm.setCurrentSessionProperty("IOStyle",iostyle);

	    String workspace=
		parseXML.getMatchTag(code, machine,"WorkDir");
	    cm.setCurrentSessionProperty("WorkDir",workspace);

	    codenameflag=false;
	    machinenameflag=false;
	}
    }

    public void setIOArrayRequests(HttpServletRequest request, boolean flag){

	if(flag) {
	    String NumOfInParam = cm.getCurrentSessionProperty("NumInParams");
	    String NumOfOutFiles = cm.getCurrentSessionProperty("NumOutFiles");
	    String NumOfInFiles=cm.getCurrentSessionProperty("NumInFiles");
	    String NumOfOutParams=cm.getCurrentSessionProperty("NumOutParams");

	    String[] inputpath = null;	
	    String[] outputpath = null;
	    String[] inputparams=null;
	    String[] outputparams=null;

	    String catinpath="",catoutpath="",catinparams="",catoutparams="";

	    if (!NumOfInParam.equals("0")) {
	
		inputparams=request.getParameterValues("inputparameter");
		for(int i=0;i<inputparams.length;i++) catinparams+=inputparams[i]+"+";
	    }		
	    else catinparams = "null";
	    cm.setCurrentSessionProperty("inputParam",catinparams);

	    if (!NumOfInFiles.equals("0")) {
		
		inputpath=request.getParameterValues("inputpath");
		for(int i=0;i<inputpath.length;i++) catinpath+=inputpath[i]+"+";
	    }		
	    else catinpath = "null";
	    cm.setCurrentSessionProperty("inputFiles",catinpath);
	    
	    if (!NumOfOutFiles.equals("0")) {
		outputpath=request.getParameterValues("outputpath");
		for(int j=0;j<outputpath.length;j++) catoutpath+=outputpath[j]+"+";
	    }
	    else catoutpath = "null";
	    cm.setCurrentSessionProperty("outputFiles",catoutpath);	
	    
	    if (!NumOfOutParams.equals("0")) {
		outputparams=request.getParameterValues("outputparameter");
		for(int j=0;j<outputparams.length;j++) catoutparams+=outputparams[j]+"+";
	    }
	    else catoutparams = "null";
	    cm.setCurrentSessionProperty("outputParams",catoutparams);

	} else {

	    String vtoolkit = cm.getCurrentSessionProperty("VtkCode");
	    String code = cm.getCurrentSessionProperty("codeName");
	    String machine = cm.getCurrentSessionProperty("machineName");

	    cm.setCurrentSessionProperty("VtkType","VIZ");

	    String execpath=
		parseXML.getMatchTagViz(code, machine,vtoolkit,"VizPath");
	    cm.setCurrentSessionProperty("Vtkexecpath",execpath);

	    String[] datapath = null;
	    String catoutpath="";
	    String NumOfOutFiles=cm.getCurrentSessionProperty("NumOutFiles");

	    if (!NumOfOutFiles.equals("0")) {
		datapath=request.getParameterValues("datapaths");
		for(int j=0;j<datapath.length;j++) catoutpath+=datapath[j]+"+";
	    }
	    else catoutpath = "null"; 
	    cm.setCurrentSessionProperty("DataFiles",catoutpath);
	}
    }


    /*
    public void setRequests(HttpServletRequest request) throws IOException {
	String paramName = null;
	String paramValue = null;
	byte[] buf = null;
	FileOutputStream fout = new FileOutputStream(filepath);
	Enumeration requestNames = request.getParameterNames();
	while(requestNames.hasMoreElements()) {
         paramName = (String)requestNames.nextElement();
	 buf = paramName.getBytes();
	 fout.write(buf);	 
	 paramValue = request.getParameter(paramName);
	 buf = paramValue.getBytes();
	 fout.write(buf);	 
	 System.out.println("paramName: "+paramName+";paramValue: "+paramValue);
	}      
	fout.flush();
	fout.close();
    }
    */

}

