/**
 * Program: MyToolBar.java
 * Comments: A frame to diplay the tool bar menu.
 */

package WebFlow.ToolBar;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import WebFlow.*;
import org.omg.CORBA.*;
import WebFlow.submitJob.*;
import WebFlow.SerialHash.*;

public class MyToolBar extends JFrame 
    implements ActionListener,MenuListener{

    JMenuBar menuBar;
    JMenu FileMenu,EditMenu,BrowserMenu,JobMenu,MonitorMenu,FBMenu,LocMenu;
    CmdMenuItem ExitItem,AddApp,RmApp,WBOpen,WBClose,
	JMOpen,JMClose,FBOpen,FBClose;
    AppletFrame fbApplet, jmApplet;
    Vector sjMenuVec,sjCmdVec;

    String cmd;
    String probHashDir="/app/gateway/apache_1.3.12/htdocs/GOW/WEB-INF/Descriptors/users/JSPClient/";
    
    String[] probNames=null;
    String[] probVals=null;
    String userName="gateway";
    
    //The following is temporary code until I can revise.
    String urlfile="http://dev-spt01:8080/GOW/IOR/master.txt";
    String masterIOR;
    public ORB orb;
    public WebFlowContext master=null,myContext;
    org.omg.CORBA.Object myContextObj,mySubmitObj,mySerHashObj;
    submitJob sj;
    SerialHash sh;

    public MyToolBar() {
	setTitle("GOW Tool Bar");
  	menuBar=new JMenuBar();
  	setJMenuBar(menuBar);
	sjMenuVec=new Vector();
	sjCmdVec=new Vector();
	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e){
		    System.exit(0);
		}
	    });

	//The following is temporary code.  I should do all of the 
	//orb stuff in CharonClient.
	masterIOR=WebFlow.ClientUtils.getIORFromURL(urlfile);
	orb=WebFlow.ClientUtils.initializeORB(masterIOR,orb);
	master=WebFlow.ClientUtils.getMasterServer(masterIOR,orb);

	try {
	    myContextObj=master.addNewContext(userName);
	    myContext=WebFlowContextHelper.narrow(myContextObj);
	    mySubmitObj=myContext.addNewModule("submit");
	    mySerHashObj=myContext.addNewModule("SerialHash");
	    sj=submitJobHelper.narrow(mySubmitObj);
	    sh=SerialHashHelper.narrow(mySerHashObj);
	}
	
	catch (Exception ex) {
	    ex.printStackTrace();
	}

	//I will move this to CharonClient and put value in
	//a java properties file.  Then pass with an accessor method.
	cmd="netscape http://localhost:8080";
	//	cmd+="/GOW/Generic/CharonStart.jsp";
	cmd+="/GOW/Generic/Main.jsp";

	fbApplet=new AppletFrame(new UDapplet());
	fbApplet.hide();

	jmApplet=new AppletFrame(new TrackerApplet());
	jmApplet.hide();

	/* The remainder of the constructor sets up the GUI */
	FileMenu=new JMenu("File");
	ExitItem=new CmdMenuItem("Exit");
	ExitItem.addActionListener(this);
	ExitItem.setCommand(new ExitCmd());
	FileMenu.add(ExitItem);
	menuBar.add(FileMenu);

	EditMenu=new JMenu("Edit");
	AddApp=new CmdMenuItem("Add Local Application");
	AddApp.addActionListener(this);
	AddApp.setCommand(new AddCmd());
	AddApp.setEnabled(false);
	RmApp=new CmdMenuItem("Remove Local Application");
	RmApp.addActionListener(this);
	RmApp.setCommand(new RmCmd());
	RmApp.setEnabled(false);
	EditMenu.add(AddApp);
	EditMenu.add(RmApp);
	menuBar.add(EditMenu);

	BrowserMenu=new JMenu("Web Browser");
	WBOpen=new CmdMenuItem("Open");
	WBOpen.addActionListener(this);
	WBOpen.setCommand(new WBOpenCmd(cmd));
	BrowserMenu.add(WBOpen);
	menuBar.add(BrowserMenu);

	JobMenu=new JMenu("Submit Job");
	JobMenu.add("Pending Jobs:");
	JobMenu.addSeparator();
	JobMenu.addMenuListener(this);
	menuBar.add(JobMenu);

	MonitorMenu=new JMenu("Job Monitor");
	JMOpen=new CmdMenuItem("Open");
	JMOpen.addActionListener(this);
	JMOpen.setCommand(new AppOpenCmd(jmApplet));
	JMClose=new CmdMenuItem("Close");
	JMClose.addActionListener(this);
	JMClose.setCommand(new AppCloseCmd(jmApplet));
	MonitorMenu.add(JMOpen);
	MonitorMenu.add(JMClose);
	menuBar.add(MonitorMenu);
	
	FBMenu=new JMenu("File Browser");
	FBOpen=new CmdMenuItem("Open");
	FBOpen.addActionListener(this);
	FBOpen.setCommand(new AppOpenCmd(fbApplet));
	FBClose=new CmdMenuItem("Close");
	FBClose.addActionListener(this);
	FBClose.setCommand(new AppCloseCmd(fbApplet));
	FBMenu.add(FBOpen);
	FBMenu.add(FBClose);
	menuBar.add(FBMenu);

	LocMenu=new JMenu("Local Applications");
	menuBar.add(LocMenu);

    }
    
    //I implemented the "command" design pattern for the commands so that
    //they could be separated from the code that sets up the visual 
    //components.
    public void actionPerformed(ActionEvent e){
	CommandHolder ch=(CommandHolder)e.getSource();
	ch.getCommand().Execute();
    }

    //Must override the following when implementing the MenuListener.
    public void menuCanceled(MenuEvent me){
	System.out.println("Menu Canceled");
	JMenu menuSource=(JMenu)me.getSource();
	destroyDynMenu(menuSource);
    }
    
    //This is called whenever the mouse moves away from the selected
    //menu, or an item from the menu is selected and the pop-up is
    //dismissed.
    public void menuDeselected(MenuEvent me) {
	JMenu menuSource=(JMenu)me.getSource();
	System.out.println("Menu Deselected");
	destroyDynMenu(menuSource);
    }
    
    public void menuSelected(MenuEvent me) {
	JMenu menuSource=(JMenu)me.getSource();
	System.out.println("Menu Selected");
	sh.openHash(probHashDir+userName+"/probHash");
	
	probNames=sh.getHashNames();
	probVals=sh.getHashValues();
	constructDynMenu(menuSource);
	sh.closeHash();
    }

    /**
     * Create the submit job menu dynamically from the static hash
     * table.
     */
    private void constructDynMenu(JMenu parent){
	for(int i=0;i<probNames.length;i++){
	    sjMenuVec.add(new CmdMenuItem(probNames[i]));
	    String dir=probHashDir+userName+"/probHash";
	    sjCmdVec.add(new SJCmd(probNames[i],probVals[i],sj,sh,dir));
	    ((CmdMenuItem)sjMenuVec.get(i)).
		addActionListener(this);
	    ((CmdMenuItem)sjMenuVec.get(i)).
		setCommand((SJCmd)sjCmdVec.get(i));
	    parent.add((CmdMenuItem)sjMenuVec.get(i));
	}
    }

    /**
     * The mouse has been moved away from the submit job menu, or else
     * one of the items has been selected.  Dispose of everything.
     * Note this approach relies on the garbage collector to clean up,
     * which I may regret one day.
     */
    private void destroyDynMenu(JMenu parent) {
  	for(int i=0;i<sjMenuVec.size();i++) {
//    	    ((CmdMenuItem)sjMenuVec.get(i)).removeActionListener(this);
  	    parent.remove((CmdMenuItem)sjMenuVec.get(i));
  	}
	sjMenuVec.clear();
	sjCmdVec.clear();
    }

    public static void main(String args[]) {
	MyToolBar mtb=new MyToolBar();
	mtb.pack();
	mtb.show();
    }
}

	
