/**
 * Define the command for an item in the "Submit Job" menu.
 */

package WebFlow.ToolBar;
import WebFlow.submitJob.*;
import WebFlow.SerialHash.*;
import java.util.*;

public class SJCmd implements Command {
    
    String probName,probVal,dir;
    submitJob sj=null;
    SerialHash sh=null;
    String machine,userName,command;
    
    //Weird: Note the use of "this" below is NOT redundant!
    public SJCmd(String probName,String probVal,submitJob sj,SerialHash sh,
		 String dir) {
	this.probName=probName;
	this.probVal=probVal;
	this.sj=sj;
	this.sh=sh;
	this.dir=dir;
    }
    public void Execute(){
	sh.openHash(dir);
	sh.deleteEntry(probName);
	sh.closeHash();
	
	//Take the probVal string and break it up into its components.
	//I'm assuming the order machine+userName+command.
	StringTokenizer st=new StringTokenizer(probVal,"+");
	machine=st.nextToken();
	userName=st.nextToken();
	command=st.nextToken();
	System.out.println(machine+" "+userName+" "+command);
	System.out.println(sj.execRemoteCommand(machine,userName,command,"rsh"));
    }
}
