package extensions.Java3D;
import org.escience.XSIL.*;
import java.util.*;

public class Java3DGeometry extends XSIL {

public String Java3DGeometryType;
public int nvertex = 0;
public double[] coordinates;
public float[] colors;
public float[] normals;
boolean instantiated = false;

public void construct(){
	//System.out.println("Java3DGeometry here!!");

	coordinates = null;
	colors = null;
	normals = null;
	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
			Param p = (Param)x;
			if(p.getName().equals("Java3DGeometryType"))
				Java3DGeometryType = p.getText();
		}
            if(x instanceof Array && ((Array)x).getNdim() == 2){
			Array a = (Array)x;
			if(a.getDim(1) != 3) continue;
			nvertex = a.getDim(0);
		}
	}
}

// This function does the heavy lifting of reading arrays and so on
// It is separate from the construction because it is not called unless necessary.

public void instantiate(){
	for(int ichild=0; ichild < getChildCount(); ichild++){
            XSIL x = getChild(ichild);
            if(x instanceof Param){
			Param p = (Param)x;
			if(p.getName().equals("Java3DGeometryType"))
				Java3DGeometryType = p.getText();
		}
            if(x instanceof Array && ((Array)x).getNdim() == 2){
			Array a = (Array)x;
			if(a.getDim(1) != 3) continue;
			nvertex = a.getDim(0);
                  if(3*nvertex != a.getNdata()) continue;
	
                  if(a.getName().equals("Coordinates")){
                    coordinates = a.getPrimArray().getDoubleArray(0, 3*nvertex);
                    if(coordinates.length < 3*nvertex) {
                      System.out.println("Java3D: Coordinate vector size is " + 
                        coordinates.length + " (expected " + 3*nvertex + ")");
                      coordinates = null;
                    }
                  }

                  if(a.getName().equals("Colors")){
                    colors = a.getPrimArray().getFloatArray(0, 3*nvertex);
                    if(colors.length < 3*nvertex) {
                      System.out.println("Java3D: Color vector size is " + 
                        colors.length + " (expected " + 3*nvertex + ")");
                      colors = null;
                    }
                  }

                  if(a.getName().equals("Normals")){
                    normals = a.getPrimArray().getFloatArray(0, 3*nvertex);
                    if(normals.length < 3*nvertex) {
                      System.out.println("Java3D: Normal vector size is " + 
                        normals.length + " (expected " + 3*nvertex + ")");
                      normals = null;
                    }
                  }
		}
	}
	if(nvertex == 0){
		System.out.println("ERROR: improper Java3DGeometry");
	}
  }
  public String getJava3DGeometryType() {return Java3DGeometryType;}
  public int getNvertex() {return nvertex;}
  public double[] getCoordinates() {
    if(!instantiated) instantiate();
    return coordinates;
  }
  public float[] getColors() {
    if(!instantiated) instantiate();
    return colors;
  }
  public float[] getNormals() {
    if(!instantiated) instantiate();
    return normals;
  }

  public String toString(){
    return "Java3DGeometry [" + nvertex + " vertices]";
  }
}
