package extensions.MyImage;

import org.escience.XSIL.*;
import org.escience.Xlook.*;
import java.util.Vector;
import java.awt.*;
import javax.swing.*;

public class ImageListView extends XSILView {
  ImageList il;
  MyImage current;
  ImageCanvas ic;
  Choice jcb;
  JLabel la, lb, lc;

  public void instantiate(XSIL x) {
    this.il = (ImageList)x;

    this.setLayout(new BorderLayout());
    if(il.images.size() == 0){
      this.add(new Label("No images in list"), BorderLayout.CENTER);
    } else {
      jcb = new Choice();
	for(int i=0; i<il.images.size(); i++) {
        current = (MyImage)il.images.elementAt(i);
        jcb.addItem(current.getName());
      }

	this.add(jcb, BorderLayout.NORTH);
      ic = new ImageCanvas();
      current = (MyImage)il.images.elementAt(0);
      this.add(ic, BorderLayout.CENTER);
      JPanel p = new JPanel();
	p.setLayout(new BorderLayout());
      p.add(la = new JLabel(), BorderLayout.NORTH);
      p.add(lb = new JLabel(), BorderLayout.CENTER);
      p.add(lc = new JLabel(), BorderLayout.SOUTH);
	this.add(p, BorderLayout.SOUTH);
      refresh();
    }
  }

  public void refresh(){
    ic.setImage(current.image);
    la.setText("Right Ascension, Declination: " + 
        current.RightAscension + ", " + current.Declination);
    lb.setText("Pixel min, max: " + 
        current.PixelMin + ", " + current.PixelMax);
    lc.setText("Width (degrees, pixels): " + 
        current.RegionWidth + ", " + current.ImageWidth);
    ic.repaint();
  }

  public boolean handleEvent(Event e){
    if(e.target == jcb){
	int i = jcb.getSelectedIndex();
	current = (MyImage)il.images.elementAt(i);
      refresh();
    }
    return true;
  }
}

class ImageCanvas extends Canvas {
  Image im = null;
  public void setImage(Image im) {this.im = im;}
  public void update(Graphics g)   {paint(g);}
  public void paint(Graphics g) {
    if(im != null) g.drawImage(im, 0, 0, this);
  }
}