package extensions.TimeSeries;
import org.escience.XSIL.*;
import java.util.*;

public class TimeSeries extends XSIL {
	double t0 = 0.0;
	double t1 = 0.0;
	double dt = 0.01;
	int ndata = 0;
	Array a;

	public void construct(){
		//System.out.println("TimeSeries here!!");
		for(int ichild=0; ichild < getChildCount(); ichild++){
            	XSIL x = getChild(ichild);
           		if(x instanceof Param){
				Param p = (Param)x;
				if(p.getName().equals("t0")){
					t0 = new Double(p.getText()).doubleValue();
				}
				if(p.getName().equals("t1")){
					t1 = new Double(p.getText()).doubleValue();
				}
				if(p.getName().equals("dt")){
					dt = new Double(p.getText()).doubleValue();
				}
			}
           		if(x instanceof Array && ((Array)x).getNdim() == 1){
				a = (Array)x;
				ndata = a.getNdata();
			}
		}
		if(ndata == 0){
			System.out.println("ERROR: improper TimeSeries");
		}
		if(t1 - t0 == 0.0) t1 = t0 + (ndata-1)*dt;
		if(dt == 0.0) dt = (t1 - t0)/(ndata-1);
	}

	public String toString(){
		return super.toString() + " from " + t0 + " to " + t1;
	}

	public String toLongString(){
		return super.toString() + " from " + t0 + " to " + t1;
	}

	public double getStartTime() {return t0;}

	public double getEndTime() {return t1;}

	public int getNdata() {return ndata;}

	public double getData(int i) {
		return a.getPrimArray().getDouble(i);
	}
}
