package org.escience.XSIL.PrimArray;
import java.io.*;

public class Base64Decoder extends FilterInputStream {
	private static byte[] alphabet;
	int bitsInBuf;
	int buf;

	public Base64Decoder(InputStream in) {
		super(in);
		bitsInBuf = 0;
		alphabet = new byte[123];
        String s =
		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
		int n = s.length();
		byte[] a = s.getBytes();
		for (byte i = 0; i < 64; i++) 
			alphabet[a[i]] = i;
	}

	public int read(){
		int ans = -1;
		int d;
		int bd;
		int c = myread();
		if(c == -1) return -1;
		int bc = alphabet[c];

		switch(bitsInBuf){
			case 0:
				d = myread();
				if(d == -1) return -1;
				bd  = alphabet[d];
				ans = ((bc<<2) | (bd>>4)) & 0xFF;
				buf = bd & 0xF;
				bitsInBuf = 4;
				return ans;
			case 2:
				ans = ((buf<<6) | bc) & 0xFF;
				bitsInBuf = 0;
				return ans;
			case 4:
				ans = ((buf<<4) | (bc>>2)) & 0xFF;
				bitsInBuf = 2;
				buf = bc & 0x3;
				return ans;
		}
		return -1;
	}

	private int myread() {
		int ch = -1;
		try {
			while ((ch = in.read()) != -1 && !inBASE64Alphabet(ch));
		} catch (IOException e) {
			System.out.println(e);
		}
		return ch;
	}

  public static final boolean inBASE64Alphabet(int ch) {
    switch (ch) {
      // 'A' - 'Z'
      case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
      case 'G': case 'H': case 'I': case 'J': case 'K': case 'L':
      case 'M': case 'N': case 'O': case 'P': case 'Q': case 'R':
      case 'S': case 'T': case 'U': case 'V': case 'W': case 'X':
      case 'Y': case 'Z':

      // 'a' - 'z'
      case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
      case 'g': case 'h': case 'i': case 'j': case 'k': case 'l':
      case 'm': case 'n': case 'o': case 'p': case 'q': case 'r':
      case 's': case 't': case 'u': case 'v': case 'w': case 'x':
      case 'y': case 'z':

      // '0' - '9'
      case '0': case '1': case '2': case '3': case '4': case '5':
      case '6': case '7': case '8': case '9':

      // other BASE64 characters:
      case '+': case '/':

        return true;

      default:
        return false;
    }
  }
}
