package org.escience.XSIL.PrimArray;
import java.util.Vector;
import java.io.*;

class DoubleArray extends PrimArray
{
  double defaultObj = 0;

  public DoubleArray(int primType, int blockSize){
	super.primType = primType;
	super.data = new Vector();
    super.blockSize = blockSize;
    super.rem = 0;
  }

  public void setDefaultString(String s) throws NumberFormatException{
      defaultObj = (new Double(s)).doubleValue();
  }

  public void storeFromString(String s){
    double i = defaultObj;
	try {
      i = (new Double(s)).doubleValue();
    } catch (NumberFormatException nfe) {
      i = defaultObj;
    }
    store(i);
  }

  public int storeFromStream(DataInput lin, int wanted) {
	int actual = 0;
	try {
      while(actual < wanted){
		store(lin.readDouble());
		actual++;
	  }
	} catch (IOException e) {}
	return actual;
  }

  public void store(double v){
	double[] last;
	if(super.data.size() == 0 || super.rem == super.blockSize){
		last = new double[super.blockSize];
		super.data.addElement(last);
		super.rem = 0;
    } else {
      last = (double[])super.data.lastElement();
	}
	last[rem++] = v;
  }

  public double getDouble(int i){
    int iBlock = i/super.blockSize;
    if(iBlock >= super.data.size()) return defaultObj;
    double[] block = (double[])super.data.elementAt(iBlock);
    return block[i%super.blockSize];
  }

  public byte[] getByteArray(int index, int lastindex) {
	byte[] ret = new byte[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = (byte)getDouble(i);
    return ret;
  }

  public short[] getShortArray(int index, int lastindex) {
	short[] ret = new short[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = (short)getDouble(i);
    return ret;
  }

  public int[] getIntArray(int index, int lastindex) {
	int[] ret = new int[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = (int)getDouble(i);
    return ret;
  }

  public long[] getLongArray(int index, int lastindex) {
	long[] ret = new long[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = (long)getDouble(i);
    return ret;
  }

  public boolean[] getBooleanArray(int index, int lastindex) {
	boolean[] ret = new boolean[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = 
		getDouble(i)==0.0?false:true;
    return ret;
  }

  public float[] getFloatArray(int index, int lastindex) {
	int n = lastindex - index;
	float[] ret = new float[n];
	for(int i=index; i<lastindex; i++) { ret[i-index] = (float)getDouble(i) ;}
    return ret;
  }

  public double[] getDoubleArray(int index, int lastindex) {
    int n = lastindex - index;
	double[] ret = new double[n];
	for(int i=index; i<lastindex; i++) { ret[i-index] = (double)getDouble(i); }
    return ret;
  }

  public String[] getStringArray(int index, int lastindex) {
    int n = lastindex - index;
    String[] ret = new String[n];
	for(int i=index; i<lastindex; i++) { ret[i-index] = Double.toString(getDouble(i)); }
    return ret;
  }
}
