package org.escience.XSIL.PrimArray;
import java.util.Vector;
import java.io.*;

class IntArray extends PrimArray
{
  int defaultObj = 0;

  public IntArray(int primType, int blockSize){
	super.primType = primType;
	super.data = new Vector();
    super.blockSize = blockSize;
    super.rem = 0;
  }

  public void setDefaultString(String s) throws NumberFormatException{
      defaultObj = (new Integer(s)).intValue();
  }

  public void storeFromString(String s){
    int i = defaultObj;
	try {
      i = (new Integer(s)).intValue();
    } catch (NumberFormatException nfe) {
      i = defaultObj;
    }
    store(i);
  }

  public int storeFromStream(DataInput lin, int wanted) {
	int actual = 0;
	try {
      while(actual < wanted){
		store(lin.readInt());
		actual++;
	  }
	} catch (IOException e) {}
	return actual;
  }

  public void store(int v){
	int[] last;
	if(super.data.size() == 0 || super.rem == super.blockSize){
		last = new int[super.blockSize];
		super.data.addElement(last);
		super.rem = 0;
    } else {
      last = (int[])super.data.lastElement();
	}
	last[rem++] = v;
  }

  public int getInt(int i){
    int iBlock = i/super.blockSize;
    if(iBlock >= super.data.size()) return defaultObj;
    int[] block = (int[])super.data.elementAt(iBlock);
    return block[i%super.blockSize];
  }

  public byte[] getByteArray(int index, int lastindex) {
	byte[] ret = new byte[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = (byte)getInt(i);
    return ret;
  }

  public short[] getShortArray(int index, int lastindex) {
	short[] ret = new short[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = (short)getInt(i);
    return ret;
  }

  public int[] getIntArray(int index, int lastindex) {
	int[] ret = new int[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = getInt(i);
    return ret;
  }

  public long[] getLongArray(int index, int lastindex) {
	long[] ret = new long[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = (long)getInt(i);
    return ret;
  }

  public boolean[] getBooleanArray(int index, int lastindex) {
	boolean[] ret = new boolean[lastindex - index];
	for(int i=index; i<lastindex; i++) ret[i-index] = getInt(i)==0?false:true;
    return ret;
  }

  public float[] getFloatArray(int index, int lastindex) {
	int n = lastindex - index;
	float[] ret = new float[n];
	for(int i=index; i<lastindex; i++) { ret[i-index] = (float)getInt(i) ;}
    return ret;
  }

  public double[] getDoubleArray(int index, int lastindex) {
    int n = lastindex - index;
	double[] ret = new double[n];
	for(int i=index; i<lastindex; i++) { ret[i-index] = (double)getInt(i); }
    return ret;
  }

  public String[] getStringArray(int index, int lastindex) {
    int n = lastindex - index;
    String[] ret = new String[n];
	for(int i=index; i<lastindex; i++) { ret[i-index] = Integer.toString(getInt(i)); }
    return ret;
  }
}
