package org.escience.XSIL.PrimArray;
import java.util.Vector;
import java.io.*;

class StringArray extends PrimArray
{
  public StringArray(int primType, int blockSize){
    super.primType = primType;
    super.data = new Vector();
  }

  public int size(){
	return data.size();
  }

  public void storeFromString(String s){
	store(s);
  }

  public int storeFromStream(DataInput lin, int wanted) {
//    throw ImproperStorageException; %%%
    return 0;
  }

  public void store(String s){
	data.addElement(s);
  }

  public String getString(int index) { 
    if(index >= data.size()) return "null";
    return (String)data.elementAt(index);
  }

  public byte[] getByteArray(int index, int lastindex) {
    byte[] ret = new byte[lastindex - index];
    for(int i=index; i<lastindex; i++) 
      ret[i-index] = (new Byte(getString(i))).byteValue() ;
    return ret;
  }

  public short[] getShortArray(int index, int lastindex) {
    short[] ret = new short[lastindex - index];
    for(int i=index; i<lastindex; i++) 
      ret[i-index] = (new Short(getString(i))).shortValue() ;
    return ret;
  }

  public int[] getIntArray(int index, int lastindex) {
    int[] ret = new int[lastindex - index];
    for(int i=index; i<lastindex; i++)
      ret[i-index] = (new Integer(getString(i))).intValue() ;
    return ret;
  }

  public long[] getLongArray(int index, int lastindex) {
    long[] ret = new long[lastindex - index];
    for(int i=index; i<lastindex; i++)
      ret[i-index] = (new Long(getString(i))).longValue() ;
    return ret;
  }

  public boolean[] getBooleanArray(int index, int lastindex) {
    boolean[] ret = new boolean[lastindex - index];
    for(int i=index; i<lastindex; i++) ret[i-index] =
      ret[i-index] = (new Boolean(getString(i))).booleanValue() ;
    return ret;
  }

  public float[] getFloatArray(int index, int lastindex) {
    int n = lastindex - index;
    float[] ret = new float[n];
    for(int i=index; i<lastindex; i++) { 
      ret[i-index] = (new Float(getString(i))).floatValue() ;
    }
    return ret;
  }

  public double[] getDoubleArray(int index, int lastindex) {
    int n = lastindex - index;
    double[] ret = new double[n];
    for(int i=index; i<lastindex; i++) { 
      ret[i-index] = (new Double(getString(i))).doubleValue(); 
   }
    return ret;
  }

  public String[] getStringArray(int index, int lastindex) { 
	int n = lastindex - index;
	String[] ret = new String[n];
	for(int i=index; i<lastindex; i++)
      ret[i-index] = getString(i);
	return ret;
  }
}
