package org.escience.XSIL.PrimArray;
import java.io.*;

public class Test {
  public static void main(String argv[]) {

    PrimArray pa;
	String file;
	int g;

//-----------------------------------------
    System.out.println("Reading from LittleEndian Base64 String");
	String s = "AAAAAAEAAAACAAAAAwAAAAQAAAAFAAAABgAAAAcAAAAIAAAACQAAAA==";
	pa = PrimArray.create(PrimArray.INT);
	g = pa.storeFromBase64String(s, true);
    System.out.println(g +" stored");
    for(int i=0; i<pa.size(); i++)
      System.out.println("element " + i + " is " + pa.getFloat(i));

//-----------------------------------------
    System.out.println("Reading from Strings");
    pa = PrimArray.create(PrimArray.DOUBLECOMPLEX);
	pa.storeFromString("3,1");
	pa.storeFromString("4,1");
	pa.storeFromString("5,1");
	pa.storeFromString("6,1");
	pa.storeFromString("7,1");
	pa.storeFromString("8,1");
	pa.storeFromString("9,1");
	pa.storeFromString("hd836,1");
	pa.storeFromString("10.3,1");
	pa.storeFromString("11,1");

    for(int i=0; i<pa.size(); i++)
      System.out.println("element " + i + " is " + pa.getString(i));

//-----------------------------------------
    System.out.println("Reading from File");
	pa = PrimArray.create(PrimArray.DOUBLECOMPLEX);
	try {
	  g = pa.storeFromFile("samples/BigEnd_double.bin", false, false);
	  System.out.println(g +" stored");
      for(int i=0; i<pa.size(); i++)
        System.out.println("element " + i + " is " + pa.getInt(i));
	} catch(FileNotFoundException e) {
	  System.out.println("file not found");
	}

//-----------------------------------------
    System.out.println("Reading from Little Endian Files");
	pa = PrimArray.create(PrimArray.DOUBLECOMPLEX);
	try {
	  g = pa.storeFromFile("samples/LitEnd_double.bin", false, true);
	  System.out.println(g +" stored");
      for(int i=0; i<pa.size(); i++)
        System.out.println("element " + i + " is " + pa.getInt(i));
	} catch(FileNotFoundException e) {
	  System.out.println("file not found");
	}

//-----------------------------------------
    System.out.println("Reading from Base64 Files");
	pa = PrimArray.create(PrimArray.DOUBLECOMPLEX);
	try {
	  g = pa.storeFromFile("samples/BigEnd_double_base64.txt", true, false);
	  System.out.println(g +" stored");
      for(int i=0; i<pa.size(); i++)
        System.out.println("element " + i + " is " + pa.getInt(i));
	} catch(FileNotFoundException e) {
	  System.out.println("file not found");
	}

//-----------------------------------------
    System.out.println("Reading from Base64 Little Endian Files");
	pa = PrimArray.create(PrimArray.DOUBLECOMPLEX);
	try {
	  g = pa.storeFromFile("samples/LitEnd_double_base64.txt", true, true);
	  System.out.println(g +" stored");
      for(int i=0; i<pa.size(); i++)
        System.out.println("element " + i + " is " + pa.getInt(i));
	} catch(FileNotFoundException e) {
	  System.out.println("file not found");
	}

//-----------------------------------------
    System.out.println("Exiting");
  }
}
