package org.escience.XSIL;
import org.escience.XSIL.PrimArray.*;
import java.util.*;
import java.io.*;
import java.net.*;
import org.w3c.dom.*;

public class Stream extends XSIL {
	String Text      = "";
	String Delimiter = "\n\t";
	String Encoding  = "";
	boolean isDelimitedText = false;
	boolean isBase64;
	boolean isLE;
	boolean isRemote;
	DataInputStream dis = null;
	InputStream is = null;
	StringTokenizer st = null;
	String line = null;

	public void constructor(Element e){
		super.constructor(e);
		String s;
		if(Type == null) Type = "Local";

		s = e.getAttribute("Delimiter");
		if(s != null && s.length() > 0) {
			Delimiter += s;
			isDelimitedText = true;
		}

		s = e.getAttribute("Encoding");
		if(s != null) Encoding = s.toLowerCase();

		Node node = e.getFirstChild();
		while(node != null){
			if(node.getNodeType() == Node.TEXT_NODE)
				Text += node.getNodeValue();
			node = node.getNextSibling();
		}
	
		if(Encoding.lastIndexOf("text") >= 0)
			isDelimitedText = true;
		isBase64 = (Encoding.lastIndexOf("base64") >= 0);
		isLE = (Encoding.lastIndexOf("littleendian") >= 0);
		isRemote = (Type.toLowerCase().lastIndexOf("remote") >= 0);
	}

	public boolean isStreamOfTokens() {
		return isDelimitedText;
	}

	public DataInputStream getDataInputStream() {
		if(dis != null) return dis;
		getInputStream();
		if(is == null) return null;

		if(isLE) dis = new DataInputStream(new LittleEndianDecoder(is));
		else dis = new DataInputStream(is);

		return dis;
	}

	public InputStream getInputStream() {
		InputStream is2;
		if(is != null) return is;

		if(isRemote){
			URL url;
			String file;
    			try {
      			url = new URL(Text.trim());
    			} catch(Exception e) {
      			url = null;
    			}
    			if(url == null){
/* the following is for relative filenames */
      			int q1= inputFile.lastIndexOf('/');
      			int q2= inputFile.lastIndexOf('\\');
      			int slashindex = (q1>q2 ? q1:q2) +1;
     		 		file = inputFile.substring(0, slashindex) + Text.trim();
				try {
					is2 = new BufferedInputStream(new FileInputStream(file));
				} catch (FileNotFoundException e){
					System.out.println("File " + file + " not found");
					return null;
				}
    			} else {
				try {
					is2 = new BufferedInputStream(url.openStream());
				} catch (IOException e){
					System.out.println("Bad URL " + Text);
					return null;
				}

			}
		} else { // Local
			is2 = new StringInputStream(Text);
		}

		// Base64 decoding
		is = (isBase64) ? new Base64Decoder(is2) : is2;
		return is;
	}

	public String getToken(){
		if(isRemote){
			if(dis == null) getDataInputStream();
			if(dis == null) return null;
			while(st == null || !st.hasMoreTokens()){
				try {
					line = dis.readLine();
				} catch (IOException e) {
					return null;
				}
				if(line == null) return null;
				st = new StringTokenizer(line, Delimiter);
			}
			return st.nextToken().trim();
		} else {
			if(st == null)
				st = new StringTokenizer(Text, Delimiter);
			if(st.hasMoreTokens())
				return st.nextToken().trim();
			else
				return null;
		} 
	}

    public String toLongString(){
		String s = super.toString() + "\n";
		s += "\tisRemote: " + isRemote + "\n";
		s += "\tisDelimitedText: " + isDelimitedText + "\n";

		s += "\tisBase64: " + isBase64 + "\n";
		s += "\tisLittleEndian: " + isLE + "\n";
		s += "\tText is     : " + Text + "\n";
		return s;
    }

	public void objectToXSILString(
		PrintStream out, Hashtable h, String indent) {}
}
