package org.escience.XSIL;
import java.util.*;
import java.io.*;
import java.text.*;
import org.w3c.dom.*;

// Does not handle leap seconds properly */

public class Time extends XSIL {
	public static final long gpsminusunix = 315964800;
	String Text = "";
	long GPSsecs;
	long GPSnano;
	Date date;
	TimeZone tz;
	DateFormat df;

	public void constructor(Element e){
		super.constructor(e);
		tz = TimeZone.getTimeZone("GMT");
		df = DateFormat.getDateTimeInstance();
		df.setTimeZone(tz);

        Node node = e.getFirstChild();
        while(node != null){
            if(node.getNodeType() == Node.TEXT_NODE)
                Text += node.getNodeValue();
            node = node.getNextSibling();
        }

		String etype = e.getAttribute("Type");
		GPSsecs = 0;
		GPSnano = 0;
		if(etype.equals("ISO-8601")) {
			SimpleDateFormat formatter = 
				new SimpleDateFormat("yyyy-MM-ddThh:mm:ss"); 
			try {
				date = formatter.parse(Text); 
			} catch (ParseException pe) {
				System.out.println("Cannot parse date " + Text);
			}
		} else {
			StringTokenizer st = new StringTokenizer(Text, " .");
			if(st.hasMoreTokens()) {
				String s = st.nextToken();
				try {
					GPSsecs = new Long(s.trim()).longValue();
				} catch (NumberFormatException nfe) {
					System.out.println("Cannot read time " + Text);
				}
                  }
                  if(st.hasMoreTokens()) {
				String s = st.nextToken();
				try {
					GPSnano = new Long(s.trim()).longValue();
				} catch (NumberFormatException nfe) {
					System.out.println("Cannot read time " + Text);
				}
			}
		}
		if(etype.equals("UNIX")) {
			GPSsecs -= gpsminusunix;
		}

		date = new Date(1000*(long)(GPSsecs + gpsminusunix) + GPSnano/1000000);
	//	System.out.println(toUTC());
	}

	public String toUTC() {
		return df.format(date);
	}

	public String getText() {
		return Text;
	}

	public String toString(){
		return super.toString() + "[" + toUTC() + "]";
	}

	public String toLongString(){
		return 
			super.toString() + "\n" +
			"\tValue: " + Text + "\n" + 
			"\tGPS: " + GPSsecs +
			"\tUTC: " + toUTC() + "\n";
	}

    public void objectToXSILString(
        PrintStream out, Hashtable h, String indent) {

        out.println(indent +
            "<Time" + makeNameTypeTags() + ">"
            + Text +
            "</Time>");
    }
}
