package org.escience.XSIL;
import java.io.*;
import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import com.ibm.xml.parser.*;

public class XSIL {
	Element e = null;
	boolean debug;
	String Classtag = null;
	String Name = null;
	String Type = null;
	Vector children = null;
	XSIL parent = null;
	ErrorEater error = null;
	boolean tryAgain;
      static String inputFile;

	public XSIL(String filename){
		this(filename, true);
	}

	public XSIL(String filename, boolean debug){
		this(filename, debug, null);
	}

	public XSIL(String filename, boolean debug, ErrorEater error){
		TXDocument doc;
		this.error = error;
		this.debug = debug;
		tryAgain = false;
		inputFile = filename;

		doc = parseIt(filename, error);

		// There was a problem finding the DTD. 
		// Do it again without validation
		if(tryAgain) doc = parseIt(filename, error);

		e = doc.getDocumentElement();
		parent = null;
		if(e == null){
			if(error != null) error.println("Null Document!");
			else System.out.println("Null Document!");
			return;
		}

		/* recursively traverse the parse tree */
		constructor(e);

		if(debug) {
			if(error != null) error.println("Document parsed");
			else System.out.println("Document parsed");
		}
		bottomup_constructor();
	}

	TXDocument parseIt(String filename, ErrorEater error){
        InputStream is = null;
		Parser parser;

  if (filename == null || filename.equals("")){
    System.out.println("Bad Filename!");
      return null;
   }

        try {
            is = new FileInputStream(filename);
        } catch (FileNotFoundException notFound) {
            System.err.println(notFound);
        }

		if(error == null) parser = new Parser(filename);
		else              parser = new Parser(filename, error, null);

		// DTDProblemSolver d = new DTDProblemSolver();
		// parser.addPreRootHandler(d);

		if(tryAgain){
			parser.setElementFactory(new TXDocument() {
				public boolean isCheckValidity() { return false; }
			});
		}

        TXDocument doc = parser.readStream(is);

		if(parser.getNumberOfErrors() > 0){
			if(error != null) {
				error.println("Parsing Error!");
			} else {
				System.out.println("Parsing Error!");
			}
		}

		return doc;
	}


	public void constructor (Element e){
		this.e = e;
		Classtag = e.getTagName();
		Name =  e.getAttribute("Name");
		Type =  e.getAttribute("Type");

		NodeList nl = e.getChildNodes();
		int count = 0;
		for(int i=0; i<nl.getLength(); i++){
			Node node = nl.item(i);
			if(node instanceof Element){
				if(children == null) children = new Vector();

				Element childe = (Element)node;
				String tag = childe.getTagName();
				String childClassName = tag;
				tag = multipleNameHack(tag);

				XSIL x = null;

				/* class comes from tag name */
				try {
					x = (XSIL)Class.
						forName("org.escience.XSIL." + tag).newInstance();
				} catch(Exception excep) {
					if(error != null)
					error.println("Cannot load class " + tag + ".class");
					else
					System.out.println("Cannot load class " + tag + ".class");
//					excep.printStackTrace();
				}

				/* class comes from type of an XSIL element */
				if(tag.equals("XSIL")){
					tag = childe.getAttribute("Type");
					if(!tag.equals("")) {
						XSIL xnew = null;
//String classPath = System.getProperty("java.class.path",".");
//System.out.println("Classpath is " + classPath);
						try {
							xnew = (XSIL)Class.
							forName("extensions." + tag).newInstance();
						} catch(Exception excep) {}

						if(xnew == null) 
						try {
							xnew = (XSIL)Class.
							forName("org.escience.XSIL." + tag).newInstance();
						} catch(Exception excep) {}

						if(xnew != null) {
							System.out.println("Found extension " + tag);
							x = xnew;
							childClassName = tag;
						} else {
							System.out.println("Extension " + tag + " not found ... using generic");
						}
					}
				}

				if(x != null){
					children.addElement(x);
					x.setParent(this);
					x.constructor(childe);
					x.setClasstag(childClassName);
// System.out.println("Child added from " + this + " to " + x);
				}
			}
		}
	}

	void bottomup_constructor(){
		XSIL child;
		if(children != null){
			for(int i=0; i<children.size(); i++){
				child = (XSIL)(children.elementAt(i));
				child.bottomup_constructor();
			}
		}
		construct();
	}
	public void construct() {
		// this method is overridden in extensions to allow them to set 
		// themselves up. Children call this before parents do.
		// System.out.println("Element=" + Classtag + " Name=" + Name + " Type=" + Type);
	}

	String multipleNameHack(String tag) {
		if(tag.equals("LIGO_LW")) return "XSIL";
		if(tag.equals("DigitalSky")) return "XSIL";
		else return tag;
	}

	public XSIL(){ }

	public XSIL getXSIL(String className){
		return getXSIL(className, null, null, true);
	}
	public XSIL getXSIL(String className, String nameName){
		return getXSIL(className, nameName, null, true);
	}
	public XSIL getXSIL(String className, String nameName, String typeName){
		return getXSIL(className, nameName, typeName, true);
	}
	public XSIL getXSIL(String className, boolean recurse){
		return getXSIL(className, null, null, recurse);
	}
	public XSIL getXSIL(String className, String nameName, boolean recurse){
		return getXSIL(className, nameName, null, recurse);
	}

	public XSIL getXSIL(
			String className, 
			String nameName, 
			String typeName, 
			boolean recurse){

		if(debug) 
			System.out.println("getXSIL: " + this + " searching " + 
			className + nameName + typeName); 

		if(itFits(className, nameName, typeName)){
			if(debug) System.out.println("getXSIL found" + this);
			return this;
		}

		if(recurse){
			if(children == null) return null;
			for(int i=0; i<children.size(); i++){
				XSIL x = (XSIL)children.elementAt(i);
				XSIL y = x.getXSIL(className, nameName, typeName, true);
				if(y != null) return y;
			}
		} else {
			for(int i=0; i<children.size(); i++){
				XSIL x = (XSIL)children.elementAt(i);
				if(x.itFits(className, nameName, typeName)){
					System.out.println("getXSIL found" + x);
					return x;
				}
			}
		}
			
		return null;
	}

	boolean itFits(String className, String nameName, String typeName) {
		return
			((className == null) || this.getClasstag().equals(className)) &&
			((nameName == null) || this.getName().equals(nameName)) &&
			((typeName == null) || this.getType().equals(typeName));
	}

	public XSIL getParent(){ 
		return parent;
	}

	void setParent(XSIL parent){ 
		this.parent = parent;
	}

	public int getChildCount() {
		if(children == null) return 0;
		return children.size();
	}

	public boolean hasChildNodes() {
		boolean has = (this.getChildCount() > 0);
		return has;
	}

	public int getIndexOfChild(XSIL child) {
		for(int i=0; i<children.size(); i++)
			if(child == children.elementAt(i))
					return i;
		return -1;
	}

	public XSIL getChild(int index)
	{
		if(children == null) return null;
		return (XSIL)(children.elementAt(index));
	}

	public Stream getStream() {
		if(debug)
			System.out.println("Looking for stream in " + this.getName());

		XSIL s = this.getXSIL("Stream");
		if(s instanceof Stream){
			if(debug) 
				System.out.println("Got stream name " + s.getName());
			return (Stream)s;
		} else {
			if(debug) System.out.println("Looking for stream in " + 
				this.getParent());
			s = this.getParent().getXSIL("Stream");
			if(s instanceof Stream){
				if(debug) System.out.println("Got stream name " + s.getName());
				return (Stream)s;
			}
		}
		return null;
	}

	Element getElement() {
		return e;
	}

	public String getName() { return Name; }
	public String getType() { return Type; }
	public String getClasstag() { return multipleNameHack(Classtag); }
	public void setClasstag(String t) { Classtag = t; }

	public String toString(){
		return Classtag + makeNameTypeTags();
	}

	String makeNameTypeTags(){
		String s = "";
		if(Name != null && Name.length() > 0) {
			s += " Name=\"" + Name + "\"";
		} 
		if(Type != null && Type.length() > 0) {
			s += " Type=\"" + Type + "\"";
		}
		return s;
	}

	public String toLongString() {
		return toString();
	}

	public void toXSILString(PrintStream out, Hashtable h) {
		out.println("<?xml version=\"1.0\"?>");
		String dtd = System.getProperty("dtd.path");
		if(dtd == null)
			out.println("<!DOCTYPE XSIL SYSTEM \"xsil.dtd\">");
		else
			out.println("<!DOCTYPE XSIL SYSTEM \"" + dtd + "\">");
		objectToXSILString(out, h, "");
	}

	public void objectToXSILString(
		PrintStream out, Hashtable h, String indent) {

		out.println(indent + "<XSIL" + makeNameTypeTags() + ">");

		if(children != null){
			for(int ichild=0; ichild < children.size(); ichild++){
				Object o = children.elementAt(ichild);
				if(o instanceof XSIL) {
					((XSIL)o).objectToXSILString(out, h, indent + "  ");
				}
			}
		}
		out.println(indent + "</XSIL>");
	}
}
