package org.escience.Xlook;

import org.escience.XSIL.*;
import org.escience.XSIL.PrimArray.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import jclass.table3.*;

public class TableView extends XSILView {
  LiveTable kltable = new LiveTable();
  org.escience.XSIL.Table xt;

  public void instantiate(XSIL xxt) {
    this.xt = (org.escience.XSIL.Table)xxt;
    this.setLayout(new BorderLayout());
    this.setSize(400,300);

	TableModel tm = new TableModel(xt);
	kltable.setColumnTrigger(Event.SHIFT_MASK, LabelTrigger.SORT);
	JCCellRange range = new JCCellRange
		(0,0, tm.getNumRows()-1, tm.getNumColumns()-1);
	kltable.setBackground(range, new Color(255,228,196)); 
	kltable.setDataSource(tm);

    this.add(kltable, BorderLayout.CENTER);
  }
}

class TableModel implements TableData {
	org.escience.XSIL.Table xTable;

	public TableModel(org.escience.XSIL.Table xTable) {
		this.xTable = xTable;
	}

	public int getNumRows() {
		return xTable.getNRow();
	}

	public int getNumColumns() {
		return xTable.getNColumn();
	}

	public Object getTableRowLabel(int r) {
		return null;
	}

	public Object getTableColumnLabel(int c) {
		return xTable.getColumn(c).getName();
	}

	public Object getTableDataItem(int r, int c) {
		PrimArray pa = xTable.getColumn(c).getPrimArray();
		switch(pa.getType()){
		case PrimArray.BYTE: return new Byte(pa.getByte(r));
		case PrimArray.SHORT: return new Short(pa.getShort(r));
		case PrimArray.INT: return new Integer(pa.getInt(r));
		case PrimArray.LONG: return new Long(pa.getLong(r));
		case PrimArray.BOOLEAN: return new Boolean(pa.getBoolean(r));
		case PrimArray.FLOAT: return new Float(pa.getFloat(r));
		case PrimArray.DOUBLE: return new Double(pa.getDouble(r));
		default: return pa.getString(r);
		}
	}

	public void addTableDataListener(TableDataListener l) { }
	public void removeTableDataListener(TableDataListener l) { }
}
