package org.escience.Xlook;
import org.escience.XSIL.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.text.*;
import javax.swing.event.*;

public class Viewer extends JFrame implements ActionListener {
	JButton quitButton;

	public Viewer (XSIL x) {
		super("XSIL Component Viewer");
		this.setSize(400, 500);
		getContentPane().setLayout(new BorderLayout());

		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new BorderLayout());

		quitButton = new JButton("Quit");
		quitButton.setSize(40,20);
		quitButton.addActionListener(this);
		buttonPanel.add(quitButton, BorderLayout.NORTH);

		JTextPane textPane = getTextPane(x);
		buttonPanel.add(textPane, BorderLayout.CENTER);

		getContentPane().add(buttonPanel, BorderLayout.NORTH);

		XSILView viewComponent = null;
		String tag = x.getClasstag();

System.out.println("Looking for View extension for " + tag);
		try {
			viewComponent = (XSILView)Class.
			forName("extensions." + tag + "View").newInstance();
		} catch(Exception excep) {}

		if(viewComponent == null) 
		try {
			viewComponent = (XSILView)Class.
			forName("org.escience.Xlook." + tag + "View").newInstance();
		} catch(Exception excep) {}

		if(viewComponent != null) {
System.out.println("Found View extension for " + x.getClasstag());
			viewComponent.instantiate(x);
			JScrollPane jsp = new JScrollPane(viewComponent);
			jsp.setVisible(true);
			jsp.setSize(400,300);
			getContentPane().add(jsp, BorderLayout.CENTER);
		} else {
System.out.println("View extension for " + tag + " not found ... using generic");
		}
	}

	public void actionPerformed(ActionEvent ae) {
		if (ae.getActionCommand().equals("Quit")) {
			dispose();
		}
	}

	public JTextPane getTextPane(XSIL x) {
		JTextPane tp = new JTextPane();
		tp.setSize(400,200);
		SimpleAttributeSet att = new SimpleAttributeSet();
		Document doc = tp.getDocument();
		StyleConstants.setFontFamily(att, "Serif");

		StyleConstants.setFontSize(att, 24);
		StyleConstants.setBold(att, true);
		StyleConstants.setForeground(att, Color.blue);
		append(doc, x.getClasstag() + "\n", att);

		StyleConstants.setFontSize(att, 18);
		StyleConstants.setBold(att, false);
		StyleConstants.setForeground(att, Color.black);
		append(doc, "Name =" + x.getName() + "\n", att);
		append(doc, "Type =" + x.getType() + "\n", att);

		return tp;
	}

	private void append(Document doc, String s, SimpleAttributeSet att) {
		try {
			doc.insertString(doc.getLength(), s, att);
		} catch(BadLocationException e) { }
	}
}
